<?php
if( !defined('ABSPATH') )
	exit();
if( !class_exists('WPO_pressticket_METABOX') ){
	class WPO_pressticket_METABOX {
		var $department_tax = 'department';
		var $post_type = 'wp-ticket';
		function __construct(){
			add_action('admin_notices', array($this,'alert_advanced_custom_field'));
			add_action('init', array($this,'register_field_group'));
			//add_action('init', array($this,'get_all_departments'));
			add_action( 'save_post', array($this,'save_post'),1);
			add_action('admin_notices', array($this,'alert_purchase_key'));
			return;
		}
		### Advanced Custom Fields
		function alert_advanced_custom_field(){
			if( !function_exists('register_field_group') ){
				_e('<div class="updated"><p> '. sprintf('Please install <strong>%s</strong> to create the ticket in Backend.', '<a target="_blank" href="http://wordpress.org/plugins/advanced-custom-fields/">'.__('Advanced Custom Fields','wpo').'</a>' ) .'</p></div>','wpo');
			}
		}
		function alert_purchase_key(){
			global $post;
			global $pagenow;
			if( $_GET['post'] && $pagenow =='post.php'&& $post->ID && wpo_ticket_option_envato_enable()=='yes' && get_post_type($post->ID)=='wp-ticket' ){
				if(class_exists('WPO_purchasekey_verifier')){
					$WPO_purchasekey_verifier = new WPO_purchasekey_verifier();
				}	
				$purchase_key = $WPO_purchasekey_verifier->verifier( get_post_meta($post->ID,'wpo_ticket_envato_purchase_key',true) );
				if($purchase_key['resp'] =='error' ){
					$this->pending_ticket($post->ID);
					_e('<div class="error"><p> '. __('Your ticket still Pending until You enter a valid Purchase Key','wpo') .'</p></div>','wpo');
				}
			}
		}
		function pending_ticket($post_id){
			global $wpdb;
			if( !$post_id )
				return;			
			if( get_post_type( $post_id ) != $this->post_type  )
				return;
			return $wpdb->update($wpdb->posts, array('post_status'=>'pending'), array('ID'=>$post_id));
		}
		function get_all_departments(){
			//$department = array();
			$args = array(
			    'orderby'       => 'name', 
			    'order'         => 'ASC',
			    'hide_empty'    => false, 
			    'fields'        => 'all', 
			    'hierarchical'  => true
			); 			
			$terms = get_terms($this->department_tax, $args);
			if( $terms ){
				//$department[]	=	__('Choose one ...','wpo');
				foreach ($terms as $term){
					$department[$term->term_id] = $term->name; 
				}
			}
			return $department;
		}
		function get_all_helptopic(){
			return array(
				''	=>	__('Choose one ...','wpo')
			);
		}
		function save_post($post_id){		
			//$post_ID = $_POST['post_ID'];
			$fields = $_POST['fields'];
			if( wpo_ticket_option_envato_enable()=='yes' ){
				$purchase_key = $fields['wpo_ticket_envato_purchase_key'];
				if( !empty( $purchase_key ) ){
					if(class_exists('WPO_purchasekey_verifier')){
						$WPO_purchasekey_verifier = new WPO_purchasekey_verifier();
					}					
					$purchase_key_verify = $WPO_purchasekey_verifier->verifier($purchase_key);
					
					if( $purchase_key_verify['resp'] =='error' ){
						return $this->pending_ticket($post_id);
					}
					elseif( $purchase_key_verify['resp'] =='success' ){
						if( $purchase_key_verify['buyer'] != trim( $fields['wpo_ticket_envato_buyer'] ) ){
							return $this->pending_ticket($post_id);
						}
						else{
							update_post_meta($post_id, 'wpo_ticket_envato_purchase_key', $purchase_key);
							update_post_meta($post_id, 'wpo_ticket_envato_item_name', $purchase_key_verify['item_name']);
							update_post_meta($post_id, 'wpo_ticket_envato_item_id', $purchase_key_verify['item_id']);
							update_post_meta($post_id, 'wpo_ticket_envato_created_at', $purchase_key_verify['created_at']);
							update_post_meta($post_id, 'wpo_ticket_envato_buyer', $purchase_key_verify['buyer']);
							update_post_meta($post_id, 'wpo_ticket_envato_licence', $purchase_key_verify['licence']);		
							update_post_meta($post_id, 'wpo_ticket_type', 'envato');				
						}
					}
					else{
						return;
					}
				}
			}
			
			if( $fields['wpo_ticket_department'] && $post_id && get_post_type($post_id) =='wp-ticket' ){
				$department = (int)$fields['wpo_ticket_department'];
				wp_set_post_terms($post_id,$department,'department',false);
				### send the notification
				if( class_exists('WPO_pressticket_notifications')){
					$mail = new WPO_pressticket_notifications();
					$mail->supporter_ticket_alert($post_id, $department);
				}
			}
		}
		function register_field_group(){
			global $post;
			if(function_exists("register_field_group")){
				if( wpo_ticket_option_envato_enable()=='yes' ):
				register_field_group(array (
					'id' => '52898de04c1da',
					'title' => 'Envato Information',
					'fields' => 
					array (
						0 => 
						array (
							'key' => 'wpo_ticket_envato_purchase_key',
							'label' => __('Purchase Key','wpo'),
							'name' => 'wpo_ticket_envato_purchase_key',
							'type' => 'text',
							'order_no' => 0,
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => 
							array (
								'status' => 0,
								'rules' => 
								array (
									0 => 
									array (
										'field' => 'null',
										'operator' => '==',
										'value' => get_post_meta($post->ID,'wpo_ticket_envato_purchase_key',true) ? get_post_meta($post->ID,'wpo_ticket_envato_purchase_key',true) : null,
									),
								),
								'allorany' => 'all',
							),
							'default_value' => '',
							'formatting' => 'none',
						),
						1 => 
						array (
							'key' => 'wpo_ticket_envato_buyer',
							'label' => __('Envato Account','wpo'),
							'name' => 'wpo_ticket_envato_buyer',
							'type' => 'text',
							'order_no' => 0,
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => 
							array (
								'status' => 0,
								'rules' => 
								array (
									0 => 
									array (
										'field' => 'null',
										'operator' => '==',
										'value' => get_post_meta($post->ID,'wpo_ticket_envato_buyer',true) ? get_post_meta($post->ID,'wpo_ticket_envato_buyer',true) : null,
									),
								),
								'allorany' => 'all',
							),
							'default_value' => '',
							'formatting' => 'none',
						)						
					),
					'location' => 
					array (
						'rules' => 
						array (
							0 => 
							array (
								'param' => 'post_type',
								'operator' => '==',
								'value' => 'wp-ticket',
								'order_no' => 0,
							),
						),
						'allorany' => 'all',
					),
					'options' => 
					array (
						'position' => 'normal',
						'layout' => 'default',
						'hide_on_screen' => 
						array (
						),
					),
					'menu_order' => 0,
				));
				endif;
				/********* end envato purchase key**********/
				$default_department = wp_get_post_terms( $post->ID, 'department', NULL );	
				register_field_group(array (
					'id' => '52898de04f625',
					'title' => __('Ticket Information','wpo'),
					'fields' => 
					array (
						0 => 
						array (
							'key' => 'wpo_ticket_department',
							'label' => __('Department','wpo'),
							'name' => 'department',
							'type' => 'select',
							'order_no' => 0,
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => 
							array (
								'status' => 0,
								'rules' => 
								array (
									0 => 
									array (
										'field' => 'null',
										'operator' => '==',
										'value' => '',
									),
								),
								'allorany' => 'all',
							),
							'choices' => $this->get_all_departments(),
							'default_value' => $default_department[0]->term_id,
							'allow_null' => 0,
							'multiple' => 0,
						),
						1 => 
						array (
							'key' => 'pressticket_helptopics',
							'label' => __('Help Topic','wpo'),
							'name' => 'wpo_ticket_helptopics',
							'type' => 'select',
							'order_no' => 0,
							'instructions' => '',
							'required' => 0,
							'conditional_logic' => 
							array (
								'status' => 0,
								'rules' => 
								array (
									0 => 
									array (
										'field' => 'null',
										'operator' => '==',
										'value' => '',
									),
								),
								'allorany' => 'all',
							),
							'choices' => $this->get_all_helptopic(),
							'default_value' => '',
							'allow_null' => 0,
							'multiple' => 0,
						),						
						2 => 
						array (
							'key' => 'pressticket_field_5',
							'label' => __('Priority','wpo'),
							'name' => 'wpo_ticket_priority',
							'type' => 'select',
							'order_no' => 1,
							'instructions' => '',
							'required' => 1,
							'choices' => wpo_ticket_get_priority_options(),
							'default_value' => '',
							'allow_null' => 0,
							'multiple' => 0,
						),
						3 => 
						array (
							'key' => 'pressticket_field_6',
							'label' => __('Status','wpo'),
							'name' => 'wpo_ticket_status',
							'type' => 'select',
							'order_no' => 2,
							'instructions' => '',
							'required' => 1,
							'choices' => wpo_ticket_get_status_options(),
							'default_value' => '',
							'allow_null' => 0,
							'multiple' => 0,
						),
					),
					'location' => 
					array (
						'rules' => 
						array (
							0 => 
							array (
								'param' => 'post_type',
								'operator' => '==',
								'value' => 'wp-ticket',
								'order_no' => 0,
							),
						),
						'allorany' => 'all',
					),
					'options' => 
					array (
						'position' => 'side',
						'layout' => 'default',
						'hide_on_screen' => 
						array (
						),
					),
					'menu_order' => 0,
				));
				if( wpo_ticket_option_ticket_woo_enable()=='yes' ):
				register_field_group(array (
					'id' => '52898de0562cb',
					'title' => __('WooCommerce','wpo'),
					'fields' => 
					array (
						0 => 
						array (
							'key' => 'pressticket_field_7',
							'label' => __('Item related','wpo'),
							'name' => 'wpo_ticket_related_product',
							'type' => 'post_object',
							'order_no' => 0,
							'instructions' => '',
							'required' => 0,
							'conditional_logic' => 
							array (
								'status' => 0,
								'rules' => 
								array (
									0 => 
									array (
										'field' => 'null',
										'operator' => '==',
										'value' => '',
									),
								),
								'allorany' => 'all',
							),
							'post_type' => 
							array (
								0 => 'product',
							),
							'taxonomy' => 
							array (
								0 => 'all',
							),
							'allow_null' => 0,
							'multiple' => 0,
						),
					),
					'location' => 
					array (
						'rules' => 
						array (
							0 => 
							array (
								'param' => 'post_type',
								'operator' => '==',
								'value' => 'wp-ticket',
								'order_no' => 0,
							),
						),
						'allorany' => 'all',
					),
					'options' => 
					array (
						'position' => 'normal',
						'layout' => 'default',
						'hide_on_screen' => 
						array (
						),
					),
					'menu_order' => 0,
				));
				endif;
				/****** end woo ******/
			}
		}
	}
	new WPO_pressticket_METABOX();
}