<?php
if( !defined('ABSPATH') )
	exit();
if( !class_exists('WPO_pressticket_Networks') ){
	class WPO_pressticket_Networks {
		var $config_file = 'config.json';
		var $zip_file = 'pressticketclient.zip';
		var $visual_editor = false;
		function __construct() {
			add_action('admin_menu', array($this,'add_submenu_page'), 200);
			add_action('wp_ajax_pressticket_client_form', array($this,'create_plugin'));
			return;
		}
		function add_submenu_page(){
			add_submenu_page('edit.php?post_type=wp-ticket', __('Build Client Plugin','wpo'), __('Build Client Plugin','wpo'), 'add_users', 'wp-ticket-networks',array($this,'networks'));
		}
		function networks(){
			$html = null;
			$html .= '<div class="wrap">';
				$html .= '<div id="icon-edit" class="icon32 icon32-posts-wp-ticket"><br></div>';
				$html .= '<h2>'.__('Network Ticket Form','wpo').'</h2>';
				$html .= '<form action="" method="post" name="pressticket-create-form-client" id="pressticket-create-form-client">';
					$html .= '<table class="form-table"><tbody>';
						$html .= '<tr valign="top">';
							$html .= '<th scope="row">'.__('Your Homepage','wpo').'</th>';
							$html .= '<td>
								<input name="data[homepage]" value="'.get_bloginfo('url').'" type="text" class="regular-text">
							</td>';
						$html .= '</tr>';					
						$html .= '<tr valign="top">';
							$html .= '<th scope="row">'.__('Your Logo URL','wpo').'</th>';
							$html .= '<td>
								<input name="data[logo]" value="" type="text" class="regular-text">
								'.__('<p class="description"> '.sprintf( __('Enter Logo URL of your Ticket System, You can copy/upload and get the url %s, its must 70*70px','wpo'),'<a href="'.admin_url('upload.php').'">at here</a>').' </p>','wpo').'
							</td>';
						$html .= '</tr>';					
						$html .= '<tr valign="top">';
							$html .= '<th scope="row">'.__('Menu Title','wpo').'</th>';
							$html .= '<td><input name="data[menu_title]" value="'.get_bloginfo('name').'" type="text" class="regular-text"></td>';
						$html .= '</tr>';
						$html .= '<tr valign="top">';
							$html .= '<th scope="row">'.__('Page Title','wpo').'</th>';
							$html .= '<td><input name="data[page_title]" value="'.get_bloginfo('name').'" type="text" class="regular-text"></td>';
						$html .= '</tr>';						
						$html .= '<tr valign="top">';
							$html .= '<th scope="row">'.__('Department Field Support','wpo').'</th>';
							$html .= '<td><input name="data[department]" checked type="checkbox"></td>';
						$html .= '</tr>';
						$html .= '<tr valign="top">';
							$html .= '<th scope="row">'.__('Priority Field Support','wpo').'</th>';
							$html .= '<td><input name="data[priority]" checked type="checkbox"></td>';
						$html .= '</tr>';
						$html .= '<tr valign="top">';
							$html .= '<th scope="row">'.__('Status Field Support','wpo').'</th>';
							$html .= '<td><input name="data[status]" checked type="checkbox"></td>';
						$html .= '</tr>';
						$html .= '<tr valign="top">';
							$html .= '<th scope="row">'.__('Visual Editor Support','wpo').'</th>';
							$html .= '<td>
								<input name="data[visualeditor]" checked type="checkbox">
								<p class="description">'.__('If actived, Plugin will use WP Default Editor (Recommended)','wpo').'</p>
							</td>';
						$html .= '</tr>';
						$html .= '<tr valign="top">';
							$html .= '<th scope="row">'.__('Text before Ticket Form','wpo').'</th>';
							$html .= '<td>'.$this->get_editor('', 'pressticket-content-beforeform', 'data[beforeform]', false).'</td>';
						$html .= '</tr>';
						$html .= '<tr valign="top">';
							$html .= '<th scope="row">'.__('Text after Ticket Form','wpo').'</th>';
							$html .= '<td>'.$this->get_editor('', 'pressticket-content-afterform', 'data[afterform]', false).'</td>';
						$html .= '</tr>';
						$html .= '<tr valign="top">';
							$html .= '<th scope="row">'.__('Your API URL','wpo').'</th>';
							$html .= '<td>
								<input name="data[apiurl]" value="'.wpo_ticket_get_endpoint_url().'" type="text" class="regular-text">
								<code>'.sprintf( __('Change this URI? %s','wpo') , '<a href="'.admin_url('edit.php?post_type=wp-ticket&page=wp-ticket-settings').'">'.__('click here.').'</a>' ).'</code>
								<p class="description">'.sprintf(__('Check valid API url %s, if you see <strong> %s </strong>, its OK.'),'<a target="_blank" href="'.wpo_ticket_get_endpoint_url().'">'.__('CLICK HERE','wpo').'</a>', json_encode(array('resp'=>'error','message'=>'API isn\'t defined.')) ).'</p>
							</td>';
						$html .= '</tr>';						
					$html .= '<tbody></table>';
					$html .= '
						<input type="hidden" name="action" value="pressticket_client_form">
						<p class="submit">
							<input type="submit" name="submit" id="submit" class="button button-primary" value="'.__('Create Client Plugin','wpo').'">
							<img id="loading" style="display:none;" src="'.WPO_PRESSTICKET_PLUGIN_URL.'assets/img/loading.gif">
						</p>
					';
				$html .= '</form>';
				$html .= '<div id="pressticketdownload"></div>';
			$html .= '</div>';
			print $html;
		}
		function get_departments(){
			$term_data = array();
	      	$terms = get_terms('department', array(
	      		'hide_empty'	=>	false
	      	));	
	      	foreach ($terms as $term){
	      		$term_data[$term->term_id] = $term->name;
	      	}
	      	return $term_data;
		}
		function get_priority(){
			
		}
		function get_status(){
			
		}
		function create_plugin(){
			$create_json_file = false;
			if( is_admin() && current_user_can('add_users')){
				$json_file = WPO_PRESSTICKET_PLUGIN_DIR . 'client/' . $this->config_file;
				$zip_file = WPO_PRESSTICKET_PLUGIN_DIR . 'client/' . $this->zip_file;
				$zip_file_url = WPO_PRESSTICKET_PLUGIN_URL . 'client/' . $this->zip_file;
				$post_data = $_POST['data'];
				$json_data = array();
				$json_data['homepage']	=	$post_data['homepage'];
				$json_data['logo'] = $post_data['logo'];
				$json_data['brandname'] = $post_data['brandname'];
				
				if( $post_data['department']=='on' ){
					$json_data['department']	=	$this->get_departments();
				}
				if( $post_data['priority']=='on' ){
					$json_data['priority']	=	wpo_ticket_get_priority_options();
				}
				if( $post_data['status']=='on' ){
					$json_data['status']	=	wpo_ticket_get_status_options();
				}
				$json_data['visualeditor']	=	$post_data['visualeditor'];
				$json_data['beforeform']	=	stripslashes($post_data['beforeform']);
				$json_data['afterform']	=	stripslashes($post_data['afterform']);
				$json_data['apiurl']	=	$post_data['apiurl'];
				
				$write = file_put_contents($json_file, json_encode($json_data));
				if( $write !== false ){
					//echo json_encode(array('resp'=>'error','mess'=>sprintf(__('Create Settings File successfully','wpo'),'')));exit;
					$create_json_file = true;
				}
				if( $create_json_file === true ){
					$zip = new ZipArchive;
					if ($zip->open($zip_file) === TRUE) {
						$zip->addFile($json_file, 'pressticketclient/'.$this->config_file);
						$zip->close();
						echo json_encode( array('resp'=>'success', 'mess'=> sprintf( __('Create Client plugin successfully, %s and install it on your client\'s site (only for Wordpress).','wpo') , '<a href="'.$zip_file_url.'">'.__('Download','wpo').'</a>' ) ));exit();
					}
					else{
						echo json_encode(array('resp'=>'error','mess'=>__('Unzip Error: Failed to open the ZIP file.','wpo')));exit;
					}				
				}
			}
			return;
		}
		function get_editor($content, $id, $name, $media = true) {
			if( $this->visual_editor == FALSE )
				return '<textarea style="width: 50em;height:10em;" class="regular-text" name="'.$name.'"></textarea>';
			// Turn on the output buffer
			ob_start();
			$settings = array(
				'textarea_name' => $name,
				'media_buttons' => $media,
				'quicktags'	=>	false,
				'textarea_rows'	=>	10
			);
			wp_editor($content,$id, $settings);
			$editor_contents = ob_get_clean();
			return $editor_contents;			
		}				
	}
	$WPO_pressticket_Networks = new WPO_pressticket_Networks();
}