<?php
if( !defined('ABSPATH') )
	exit();
if( !class_exists('WPO_pressticket_Tickets') ){
	class WPO_pressticket_Tickets {
		function __construct(){
			add_filter('manage_edit-wp-ticket_columns' , array($this,'cpt_columns'));
			add_action( "manage_wp-ticket_posts_custom_column", array($this,'modify_column'), 10, 2 );
			add_filter( 'parse_query', array($this,'table_reorder'));
			add_action('restrict_manage_posts',array($this,'restrict_manage_ticket'));
			add_filter('parse_query', array($this,'convert_id_to_term_in_query'));
			add_filter('bulk_actions-edit-wp-ticket',array($this,'bulkaction_ticket'));
			add_action('admin_menu', array($this,'hide_ticket_menu'));
			add_action('init', array($this,'deny_ticket_page'));
		}
		function cpt_columns($columns){
			$new_columns = array(
				'type'	=>	__('Type','wpo'),
				'ticket' => __('#Ticket','wpo'),
				'ticketer'	=>	__('Author','wpo'),
				'issue'	=>	__('Issue','wpo'),
				'priority'	=>	__('Priority','wpo'),
				'status'	=>	__('Status','wpo'),
				'department'	=>	__('Department','wpo'),
				'helptopic'	=>	__('Help topic','wpo'),
				'date'	=>	__('Date','wpo')
			);
			if( current_user_can( wpo_ticket_cap_update_ticket() ) || current_user_can( wpo_ticket_cap_delete_ticket() ) ){
				$new_columns['action']	=	__('Action','wpo');
			}
			unset(
				$columns['title'],
				$columns['author'],
				$columns['comments'],
				$columns['date']
			);	
			
		    return array_merge($columns, $new_columns);			
		}
		function modify_column($column, $post_id){
			switch ($column) {
				case 'issue':
					echo '<p><strong><a title="'.get_the_title($post_id).'" target="_blank" href="'.get_permalink($post_id).'">'.substr(get_the_title($post_id), 0, 30).'</a></strong></p>';
					if( wpo_ticket_count_reply($post_id) > 1 ){
						echo '<a href="'.admin_url('edit.php?post_type=wp-ticket&page=new-reply&ticket='.$post_id).'"><span class="label">'.wpo_ticket_count_reply($post_id).' '.__('Responses','wpo').'</span></a>';	
					}
					else{
						echo '<a href="'.admin_url('edit.php?post_type=wp-ticket&page=new-reply&ticket='.$post_id).'"><span class="label">'.wpo_ticket_count_reply($post_id).' '.__('Response','wpo').'</span></a>';
					}
					break;
				case 'priority':
					echo '<a href="'.admin_url('edit.php?post_type=wp-ticket&priority='.wpo_ticket_get_ticket_priority($post_id)).'">'.wpo_ticket_hightlight_priority( wpo_ticket_get_ticket_priority($post_id, true) ).'</a>';
				break;
				case 'status':
					echo '<a href="'.admin_url('edit.php?post_type=wp-ticket&status='.wpo_ticket_get_ticket_status($post_id)).'">'. wpo_ticket_hightlight_status( wpo_ticket_get_ticket_status($post_id, true) ) .'</a>';
				break;
				case 'department':
					$department = null;
					$j=$i;
					$terms = wp_get_post_terms( $post_id, 'department', NULL );	
					for ($i = 0 ; $i < count( $terms ); $i++) {
						$end = ( $j+1 <= count( $terms ) ) ? '<br/>' : NULL;
						$department .= '<a href="'.admin_url('edit.php?post_type=wp-ticket').'&department='.$terms[$i]->term_id.'" class="label">'. $terms[$i]->name .'</a>' .$end;
					}
					print $department;
				break;
				case 'helptopic':
					echo '<span class="label">'. get_post_meta($post_id,'wpo_ticket_helptopics',true) .'</span>';
				break;
				case 'action':
					$status = wpo_ticket_get_status_options();
					if($status){
						echo '<select style="width: 100%;" name="ticket_status" class="ticket_status" post_id="'.$post_id.'">';
							foreach ($status as $k=>$v){
								if( wpo_ticket_get_ticket_status($post_id, true)==$k ){
									$select = 'selected';	
								}
								else{
									$select = NULL;
								}
								echo '<option '.$select.' value="'.$k.'" >'.$v.'</option>';
							}
						echo '</select>';
						echo '<span style="display:none" class="waiting-'.$post_id.'"><img src="'.WPO_PRESSTICKET_PLUGIN_URL.'assets/img/loading.gif"></span>';
					}
				break;
				case 'ticket':
					echo wpo_ticket_get_ticketID($post_id);
				break;
				case 'ticketer':
					if( wpo_ticket_option_envato_enable_avatar()=='yes' && get_post_meta($post_id,'wpo_ticket_envato_buyer',true) && ( get_post_meta($post_id,'wpo_ticket_type',true) =='envato' || get_post_meta($post_id,'wpo_ticket_type',true) =='woo-envato' ) ){
						$WPO_purchasekey_verifier = new WPO_purchasekey_verifier();
						echo $WPO_purchasekey_verifier->get_avatar(get_post_meta($post_id,'wpo_ticket_envato_buyer',true));
					}
					else{
						echo '<a href="'.admin_url('edit.php?post_type=wp-ticket&author='.wpo_ticket_get_author_id_post_id($post_id)).'">'.get_avatar(wpo_ticket_get_author_id_post_id($post_id), 64).'</a>';	
					}
						
				break;
				case 'type':
					echo self::ticket_type($post_id);
				break;
				default:
					echo $column;
				break;
			}			
		}
		public static function ticket_type($ticket_id) {
			$type = get_post_meta($ticket_id,'wpo_ticket_type',true);
			switch ($type) {
				case 'woo':
					return '<img src="'.WPO_PRESSTICKET_PLUGIN_URL.'assets/img/woo-icon.png">';
				break;
				case 'envato':
					return '<img src="'.WPO_PRESSTICKET_PLUGIN_URL.'assets/img/envato-icon.png">';
				break;
				case 'woo-envato':
					return '<img src="'.WPO_PRESSTICKET_PLUGIN_URL.'assets/img/woo-envato.png">';
				break;
				default:
					return '<img src="'.WPO_PRESSTICKET_PLUGIN_URL.'assets/img/wp-icon.png">';
				break;
			}
		}
		function table_reorder() {
			if(is_admin()){
				global $pagenow, $post_type;
				if( is_admin() && 'wp-ticket' == $_GET['post_type'] ){
					### Searching
					if($_GET['priority']){
						set_query_var('meta_key', 'wpo_ticket_priority');
						set_query_var('meta_value', $_GET['priority']);
						set_query_var('meta_compare', '==');			
					}
					if($_GET['status']){
						set_query_var('meta_key', 'wpo_ticket_status');
						set_query_var('meta_value', $_GET['status']);
						set_query_var('meta_compare', '==');
					}
					if($_GET['author']){
						set_query_var('author', $_GET['author']);
					}
					if(trim($_GET['ticket_id'])){
						set_query_var('meta_key', 'wpo_ticket_ID');
						set_query_var('meta_value', trim($_GET['ticket_id']));
						set_query_var('meta_compare', '==');					
					}
					if(  !current_user_can( wpo_ticket_cap_update_ticket() ) ){
						set_query_var('author', get_current_user_id());
					}
				}
			}
		}
		function restrict_manage_ticket() {
			global $typenow;
			$taxonomy = array(
				'department' =>	'Department'
			);
				
			if ($typenow=='wp-ticket' || $_GET['post_type']=='wp-ticket'){
				foreach ($taxonomy as $key=>$value){
					$args = array(
			        	'show_option_all' => "All " . $value,
			            'taxonomy'        => $key,
			            'name'               => $key,
						'hide_empty'	=>	0,
						'selected'        =>  $_GET[$key],
						'hierarchical'	=>	true,
						'show_count'	=>	true,
			        );
					wp_dropdown_categories($args);
				}
			}
			if ($typenow=='wp-ticket' || $_GET['post_type']=='wp-ticket'){
				$status = wpo_ticket_get_status_options();
				if($status){
					$statusHTML = '<select name="status">';
					$statusHTML .= '<option value="">'.__('Choose status','wpo').'</option>';
						foreach ($status as $k=>$v){
							if($_GET['status']==$k){
								$select = 'selected';
							}
							else {
								$select = NULL;
							}
							$statusHTML .= '<option '.$select.' value="'.$k.'">'.$v.'</option>';
						}
					$statusHTML .= '</select>';
					echo $statusHTML;
				}
				$priority = wpo_ticket_get_priority_options();
				if($priority){
					$priorityHTML = '<select name="priority">';
					$priorityHTML .= '<option value="">'.__('Choose priority','wpo').'</option>';
						foreach ($priority as $k=>$v){
							if($_GET['priority']==$k){
								$select = 'selected';
							}
							else {
								$select = NULL;
							}
							$priorityHTML .= '<option '.$select.' value="'.$k.'">'.$v.'</option>';
						}
					$priorityHTML .= '</select>';
					echo $priorityHTML;
				}	
				echo '<input class="input-medium ticket_id" type="search" name="ticket_id" placeholder="'.__('#Ticket ID','wpo').'" value="'.trim($_GET['ticket_id']).'">';
			}
		}
		function convert_id_to_term_in_query($query) {
			global $pagenow;
			$post_type = array('wp-ticket'); // change HERE
			$taxonomy = array(
				'department'			=>		__('Department','wpo')
			);
			$q_vars = &$query->query_vars;
			
			for ($i=0; $i<count($post_type);$i++){
				if($q_vars['post_type']==$post_type[$i]){
					foreach ($taxonomy as $key=>$value){	
						if ($pagenow == 'edit.php' && isset($q_vars['post_type']) && $q_vars['post_type'] == $post_type[$i] && isset($q_vars[$key]) && is_numeric($q_vars[$key]) && $q_vars[$key] != 0) {
							$term = get_term_by('id', $q_vars[$key], $key);
							$q_vars[$key] = $term->slug;
						}
					}
				}	
			}
		}
		function bulkaction_ticket($actions) {
			if( !current_user_can( wpo_ticket_cap_delete_ticket() ) ){
				unset($actions['trash']);	
			}
			return $actions;	
		}
		/**
		 * Hide PressTicket menu from the User, who does not allowed view the ticket.
		 */
		function hide_ticket_menu(){
			if( is_admin() && !current_user_can(wpo_ticket_cap_view_ticket()) ){
				remove_menu_page('edit.php?post_type=wp-ticket');
			}
		}
		function deny_ticket_page(){
			if( is_admin() && $_GET['post_type']=='wp-ticket' && !current_user_can(wpo_ticket_cap_view_ticket()) ){
				wp_die( __('You do not have the right permission to use this feature!','wpo') );
			}
			return;
		}
	}
	$WPO_pressticket_Ticket_Col = new WPO_pressticket_Tickets();
}