<?php
if( !defined('ABSPATH') )
	exit();
if( !class_exists('WPO_pressticket_notifications') ){
	class WPO_pressticket_notifications {
		function __construct(){
			### changed in V 2.3.1
			### Hook into pressticket_add_ticket
			add_action('pressticket_add_ticket', array($this,'supporter_ticket_alert'), 20,2);
			
			### Hook into pressticket_add_response
			add_action('pressticket_new_response', array($this,'supporter_ticket_messages'), 20, 3);
			add_action('pressticket_new_answer', array($this,'ticketer_ticket_messages'), 20, 2);
		}
		function get_customer_data($customer_id){
			global $wpdb;
			$query = $wpdb->get_row("SELECT * FROM $wpdb->users WHERE `ID` = $customer_id");
			if( $query )
				return $query;
			return null;
		}
		function get_post_authorid($post_id){
			$post = get_post($post_id);
			return $post->post_author;
		}
		function multiple_staff_email($user_id){
			$staff = array();
			if( !$user_id )
				return;
			for ($i = 0; $i < count( $user_id ); $i++) {
				$user_email = $this->get_user_byid( $user_id[$i] );
				if( is_email( $user_email ) ){
					$staff[] = $user_email;	
				}
			}
			return $staff;
		}
		function get_user_byid($user_id){
			global $wpdb;
			$query = $wpdb->get_var("SELECT `user_email` FROM $wpdb->users WHERE `ID`=$user_id");
			return $query;
		}
		/**
		 * @param int $post_id
		 * @param string $post_content
		 * @param int $department
		 */
		function return_array_emailsupporter_from_ID($id){
			$support_array = array();
			if( !$id || !is_array($id) )
				return;
			for ($i = 0; $i < count( $id ); $i++) {
				$user_data = get_user_by('id', $id[$i]);
				$support_array[] = $user_data->user_email;
			}
			return $support_array;
		}
		function wp_mail_from_name(){
			return wpo_ticket_option_helpdesk_name();
		}
		function wp_mail_from_email(){
			return wpo_ticket_option_helpdesk_email();
		}
		function get_post_content($post_id){
			$post = get_post($post_id);
			return $post->post_content;
		}
		function supporter_ticket_alert($post_id, $department){
			$headers .= "MIME-Version: 1.0\r\n";
			$headers .= "Content-Type: text/html; charset=ISO-8859-1\r\n";
			if( !$department )
				$department = wpo_pressticket_get_department($post_id);
			if( !$department )
				return;
			if( wpo_ticket_option_alert_new_tickets()!='yes')
				return;
			### check if this is an Envato Buyer
			if( wpo_ticket_option_envato_enable() =='yes' && !get_post_meta($post_id, 'wpo_ticket_envato_purchase_key',true) )
				return;
			$staff_id = wpo_ticket_get_helpers($department);
			if( $staff_id ){
				$count_staff = count( $staff_id );
				if( !$count_staff || $count_staff == 0 )
					return;
				if( get_current_user_id() ){
					### Open directly.
					$customer = get_user_by('id', get_current_user_id());
				}
				else{
					### Open via Endpoint.
					$customer_id = $this->get_post_authorid($post_id);
					$customer = $this->get_customer_data( $customer_id );
				}
				$dept = get_term($department, 'department');
				$sub =  sprintf( __('New ticket from %s','wpo'),wpo_ticket_option_helpdesk_name());		
				//$message = wpo_ticket_get_mail_new_ticket_alert();
				$message = wpo_ticket_get_mail_new_ticket_alert();
				
				### replace the shortcode	
				$search = array(
					'{recipient}'	=>	NULL,
					'{ticket.number}'	=>	wpo_ticket_get_ticketID($post_id),
					'{ticket.name}'	=>	$customer->display_name,
					'{ticket.email}'	=>	$customer->user_email,
					'{ticket.dept.name}'	=>	$dept->name,
					'{message}'	=>	$this->get_post_content($post_id),
					'{ticket.staff_link}'	=>	sprintf('%s','<a href="'.get_permalink($post_id).'">'.get_permalink($post_id).'</a>'),
					'{ticket_system}'	=>	wpo_ticket_option_helpdesk_name(),
					'{login}'	=>	get_bloginfo('url') . '/wp-login.php'				 
				);
				
				foreach ( $search as $key=>$value ){
					$message = str_ireplace($key, $value, $message);
				}
				add_filter('wp_mail_from_name', array($this,'wp_mail_from_name') );
				wp_mail($this->multiple_staff_email($staff_id), $sub, nl2br($message),$headers);
				remove_filter('wp_mail_from_name', array($this,'wp_mail_from_name') );
			}
		}
		function supporter_ticket_messages($post_id,$response_content,$department){
			$headers .= "MIME-Version: 1.0\r\n";
			$headers .= "Content-Type: text/html; charset=ISO-8859-1\r\n";			
			if( !$post_id )
				return;
			if( !$department )
				$department = wpo_pressticket_get_department($post_id);
			if( !$department )
				return;				
			if( wpo_ticket_option_alert_new_tickets()!='yes' )
				return;
			$staff_id = wpo_ticket_get_helpers($department);
			if( $staff_id ){
				$count_staff = count( $staff_id );
				if( !$count_staff || $count_staff == 0 )
					return;				
				$dept = wp_get_post_terms( $post_id, 'department',  array("fields" => "all") );
				
				//$ticketer = get_user_by('id', wpo_ticket_get_author_id_post_id($post_id));
				$customer = $this->get_post_authorid( $post_id );
				$customer = $this->get_customer_data( $customer );
				
				$sub = sprintf(__('New Message From %s','wpo'),wpo_ticket_option_helpdesk_name());
				$messages = wpo_ticket_get_mail_new_ticket_messages();
				$search = array(
					'{recipient}'	=>	NULL,
					'{ticket.name}'	=>	$customer->display_name ? $customer->display_name : $customer->user_login,
					'{ticket.email}'	=>	$customer->user_email,
					'{ticket.dept.name}'	=>	$dept[0]->name,
					'{ticket.number}'	=>	wpo_ticket_get_ticketID($post_id),
					'{message}'	=>	$response_content,
					'{ticket.staff_link}'	=>	sprintf('%s','<a href="'.get_permalink($post_id).'">'.get_permalink($post_id).'</a>')
				);
				foreach ( $search as $key=>$value ){
					$messages = str_ireplace($key, $value, $messages);
				}				
				add_filter('wp_mail_from_name', array($this,'wp_mail_from_name') );		
				wp_mail($this->multiple_staff_email( $staff_id ), $sub, nl2br($messages),$headers);
				remove_filter('wp_mail_from_name', array($this,'wp_mail_from_name') );
			}			
		}
		function ticketer_ticket_messages($post_id, $response_content){
			$headers .= "MIME-Version: 1.0\r\n";
			$headers .= "Content-Type: text/html; charset=ISO-8859-1\r\n";				
			if( !$post_id )
				return;
			if( wpo_ticket_option_alert_new_messages()!='yes' )
				return;
			$recipient = get_user_by('id', wpo_ticket_get_author_id_post_id($post_id));
			$to = $recipient->user_email;
			$sub = sprintf( __('New Response from %s for "%s"','wpo'),wpo_ticket_option_helpdesk_name(), get_the_title($post_id));
			$messages = wpo_ticket_get_mail_response();
			
			$search = array(
				'{ticket.name}'	=>	$recipient->display_name,
				'{ticket.number}'	=>	wpo_ticket_get_ticketID($post_id),
				'{response}'	=>	$response_content,
				'{ticket.client_link}'	=>	get_permalink($post_id),
				'{signature}'	=>	wpo_ticket_option_helpdesk_name()
			);
			foreach ( $search as $key=>$value ){
				$messages = str_ireplace($key, $value, $messages);
			}				
			add_filter('wp_mail_from_name', array($this,'wp_mail_from_name') );						
			wp_mail($to, $sub, nl2br($messages),$headers);
			remove_filter('wp_mail_from_name', array($this,'wp_mail_from_name') );
		}
	}
	$WPO_pressticket_notifications = new WPO_pressticket_notifications();
}