<?php 
if( !defined('ABSPATH') )
	exit();

if( !class_exists('WPO_pressticket_schedule') ){
	class WPO_pressticket_schedule {
		function __construct(){
			add_filter( 'cron_schedules', array($this,'add_intervals'));	
			add_action('init', array($this,'schedule_close_ticket'));
			add_action('ticket_schedule_close_ticket', array($this,'run_schedule_close_ticket'));
		}
		function add_intervals($schedules){
			// add a 'weekly' interval
			$schedules['10s'] = array(
				'interval' => 10,
				'display' => __('10 seconds')
			);
			$schedules['30s'] = array(
				'interval' => 30,
				'display' => __('30 seconds')
			);
			$schedules['1p'] = array(
				'interval' => 60,
				'display' => __('1 minutes')
			);
			$schedules['5p'] = array(
				'interval' => 300,
				'display' => __('5 minutes')
			);
			$schedules['10p'] = array(
				'interval' => 600,
				'display' => __('10 minutes')
			);
			$schedules['15p'] = array(
				'interval' => 900,
				'display' => __('15 minutes')
			);
			$schedules['30p'] = array(
				'interval' => 1800,
				'display' => __('30 minutes')
			);
			return $schedules;
		}
		function schedule_close_ticket() {
			if( !wp_next_scheduled('ticket_schedule_close_ticket') ){
				wp_schedule_event(time(), 'daily', 'ticket_schedule_close_ticket');
			}
		}
		function run_schedule_close_ticket(){
			if( wpo_ticket_option_close_after_x_day() > 0 ){
				global $wpdb;
				$day = -wpo_ticket_option_close_after_x_day();
				$last_modified = date('Y-m-d', strtotime((int)$day.' days'));
				$sql = "
					SELECT `ID`
					FROM $wpdb->posts
					WHERE `post_type`='wp-ticket'
						AND `post_status`='publish'
						AND `post_modified` < '" .$last_modified . "'
						order by ID ASC
				";
				$query = $wpdb->get_results($sql,ARRAY_A);
				//return $query;
				if($query){
					update_post_meta($query['ID'], 'wpo_ticket_status', 'close');
				}
			}
			else{
				return;
			}
		}
	}
	$WPO_pressticket_schedule = new WPO_pressticket_schedule();
}	