<?php
if( !defined('ABSPATH') )
	exit();
if( !class_exists('WPO_purchasekey_verifier') ){
	class WPO_purchasekey_verifier {
		var $item_id = NULL;
		var $username = null;
		function __construct() {
			add_filter('admin_notices', array($this,'admin_notices'),1);
		}
		function admin_notices(){
			$notice = NULL;
			if( wpo_ticket_option_envato_enable()=='yes' && is_admin() ){
				if($this->check_curl()!==TRUE){
					$notice = '
						<div id="setting-error-settings_updated" class="error settings-error">
							<p>'. sprintf(__('You enable %s function but Your Web Server does not support %s, Pls contact your Hosting Provider or Server Administrator.','wpo'),'<a href="'.admin_url('edit.php?post_type=wp-ticket&page=wp-ticket-settings&tab=envato').'"><strong>Envato Integrated</strong></a>','<a target="blank" href="http://php.net/manual/en/book.curl.php"><strong>CURL</strong></a>').'</p>
						</div>
					';
					echo $notice;
				}
			}
		}
		function is_purchase_code($purchase_code=NULL){
			if($purchase_code==null){
				return false;
			}
			$purchase_array = explode("-", trim( $purchase_code ));
			if(count($purchase_array)== 5 && strlen($purchase_array[0]) == 8 && strlen($purchase_array[1]) ==4 && strlen($purchase_array[2])==4  && strlen($purchase_array[3])==4 && strlen($purchase_array[4])==12){
				return true;
			}
			return false;
		}		
		function verifier($purchase_key = NULL, $envato_account = NULL, $envato_api = NULL){
			$envato_account = $envato_account ? $envato_account : wpo_ticket_option_envato_username();
			$envato_api = $envato_api ? $envato_api : wpo_ticket_option_envato_api();
			$purchase_key = trim( $purchase_key );
			if( $this->is_purchase_code($purchase_key) !==true ){
				return array(
					'resp'	=>	'error',
					'mess'	=> __('This Purchase Key is\'nt available','wpo')	
				);				
			}
			if( $this->check_curl() !==true ){
				return array(
					'resp'	=>	'error',
					'mess'	=> __('Pls contact Web Server administrator for support CURL','wpo')	
				);
			}
			if( !$purchase_key|| !$envato_account || !$envato_api )
				return array(
					'resp'	=>	'error',
					'mess'	=>	__('Something Wrong when checking Envato Settings :(','wpo')
				);
			$APIurl = 'http://marketplace.envato.com/api/edge/'.$envato_account.'/'.$envato_api.'/verify-purchase:'.$purchase_key.'.json';
			if( $this->curl($APIurl) ){
				$data = (array)json_decode($this->curl($APIurl));
				if( is_object( $data['verify-purchase'] ) && empty( $data['verify-purchase']->item_name )  ){
					return array(
						'resp'	=>	'error',
						'mess'	=> __('This Purchase Key is\'nt available','wpo')	
					);
				}
				elseif( !empty( $data['error'] ) ){
					return array(
						'resp'	=>	'error',
						'mess'	=> __($data['error'],'wpo')	
					);
				}
				elseif( !empty( $data['verify-purchase'] ) ){
					$messages = 'Item Name: ' . $data['verify-purchase']->item_name . '<br/>';
					$messages .= 'Item ID: ' .$data['verify-purchase']->item_id . '<br/>';
					$messages .= 'Created At: ' .$data['verify-purchase']->created_at . '<br/>';
					$messages .= 'Buyer: ' .$data['verify-purchase']->buyer . '<br/>';
					$messages .= 'Licence: ' .$data['verify-purchase']->licence;
					return array(
						'resp'	=>	'success',
						'item_name'	=>	$data['verify-purchase']->item_name,
						'item_id'	=>	$data['verify-purchase']->item_id,
						'created_at'	=>	$data['verify-purchase']->created_at,
						'buyer'	=>	$data['verify-purchase']->buyer,
						'licence'	=>	$data['verify-purchase']->licence
					);					
				}
			}
			return array(
				'resp'	=>	'error',
				'mess'	=>	__('The error\'s not defined!','wpo')
			);				
		}
		function check_curl(){
			if(!function_exists('curl_version'))
				return false;
			return true;
		}
		function curl($url){
			if( $this->check_curl()===true ){
				$ch = curl_init();
	            curl_setopt($ch, CURLOPT_URL, $url);
	            curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
	            curl_setopt($ch, CURLOPT_POST, 0);
				curl_setopt($ch, CURLOPT_CONNECTTIMEOUT ,400); 
				curl_setopt($ch, CURLOPT_TIMEOUT, 400); //timeout in seconds
	            $data = curl_exec($ch);
	            curl_close($ch);
	            return $data;				
			}
			return false;
		}
		function get_item(){
			if( $this->item_id == null )
				return;
			$apiURL = 'http://marketplace.envato.com/api/edge/item:'.$this->item_id.'.json';
			$data = (array)json_decode($this->curl($apiURL));
			if( !empty( $data['item'] ) ){
				return array(
					'item'	=>	$data['item']->item,
					'url'	=>	$data['item']->url
				);
			}
			return;
		}
		function get_user(){
			if( $this->username == NULL )
				return;
			$apiURL = 'http://marketplace.envato.com/api/edge/user:'.$this->username.'.json';
			$data = (array)json_decode($this->curl($apiURL));
			if( !empty( $data['user'] ) ){
				return array(
					'image'	=>	$data['user']->image,
					'country'	=>	$data['user']->country,
					'sales'	=>	$data['user']->sales ? $data['user']->sales : null,
					'location'	=>	$data['user']->location,
					'followers'	=>	$data['user']->followers,
				);
			}
			return;
		}
		function get_avatar($username){
			if( function_exists('wpo_ticket_option_envato_enable_avatar') ){
				if( wpo_ticket_option_envato_enable_avatar()=='yes' ){
					$this->username = $username;
					$userData = $this->get_user();
					return '<img style="width:64px;height:auto;" src="'.$userData['image'].'">';
				}
			}
			return $avatar;
		}
	}
	$WPO_purchasekey_verifier = new WPO_purchasekey_verifier();
}