<?php
if( !defined('ABSPATH') )
	exit();
class WPO_ticket_quickview_widget extends WP_Widget{
	function WPO_ticket_quickview_widget() {
		$widget_ops = array( 'classname' => 'wpo', 'description' => __('A widget that displays Quick view tick', 'wpo') );
		
		$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'wpo-ticket-quickview-widget' );
		
		$this->WP_Widget( 'wpo-ticket-quickview-widget', __('PressTicket Quickview', 'wpo'), $widget_ops, $control_ops );
	
	}
	function widget( $args, $instance ) {
		if( get_current_user_id() ):
		extract( $args );
		//Our variables from the widget settings.
		$title = apply_filters('widget_title', $instance['title'] );
		$show = (int)$instance['show'] ? (int)$instance['show'] : 5;
		$status = $instance['status'] ? $instance['status'] : NULL;
		$priority = $instance['priority'] ? $instance['priority'] : null;
		$class = $instance['class'] ? $instance['class'] : null;
		echo $before_widget;
		
		// Display the widget title 
		if ( $title ){
			echo $before_title . $title . $after_title;
		}
		if( class_exists('WPO_pressticket_Shortcode') ){
			$WPO_pressticket_Shortcode = new WPO_pressticket_Shortcode();
			$html = $WPO_pressticket_Shortcode->user_quicktickets(array(
				'show'=>$show,
				'status'=>$status,
				'priority'	=>	$priority,
				'class'	=>	$class
			));
		}
		else{
			_e('Can not find Shortcode Class','wpo');
		}

		echo $html;
		
		echo $after_widget;
		endif;
	}
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['show'] = (int)$new_instance['show'];
		$instance['status'] = trim($new_instance['status']);
		$instance['priority'] = trim($new_instance['priority']);
		$instance['class'] = strip_tags( $new_instance['class'] );
		return $instance;
	}
	function form( $instance ){

		//Set up some default widget settings.
		$defaults = array( 'title' => __('Ticket quickview', 'wpo'));
		$instance = wp_parse_args( (array) $instance, $defaults ); ?>
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title:', 'wpo'); ?></label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" style="width:100%;" />
		</p>
		<p>
			<label for="<?php echo $this->get_field_id( 'show' ); ?>"><?php _e('Show:', 'wpo'); ?></label>
			<input id="<?php echo $this->get_field_id( 'show' ); ?>" name="<?php echo $this->get_field_name( 'show' ); ?>" value="<?php echo $instance['show']; ?>" style="width:100%;" />
		</p>
		<p>
			<label for="<?php echo $this->get_field_id( 'status' ); ?>"><?php _e('Status:', 'wpo'); ?></label>
			<select name="<?php echo $this->get_field_name( 'status' ); ?>" id="<?php echo $this->get_field_id( 'status' ); ?>" style="width: 100%">
				<option value="">All</option>
				<?php 
					$status = wpo_ticket_get_status_options();
					foreach ($status as $k=>$v){
						?>
							<option <?php if( $instance['status']==$k ): echo 'selected';endif;?> value="<?php echo $k;?>"><?php echo $v?></option>
						<?php 
					}
				?>
			</select>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id( 'priority' ); ?>"><?php _e('Priority:', 'wpo'); ?></label>
			<select name="<?php echo $this->get_field_name( 'priority' ); ?>" id="<?php echo $this->get_field_id( 'priority' ); ?>" style="width: 100%">
				<option value="">All</option>
				<?php 
					$status = wpo_ticket_get_priority_options();
					foreach ($status as $k=>$v){
						?>
							<option <?php if( $instance['priority']==$k ): echo 'selected';endif;?> value="<?php echo $k;?>"><?php echo $v?></option>
						<?php 
					}
				?>
			</select>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id( 'class' ); ?>"><?php _e('Style list:', 'wpo'); ?></label>
			<input id="<?php echo $this->get_field_name( 'class' ); ?>" name="<?php echo $this->get_field_name( 'class' ); ?>" value="<?php echo $instance['class']; ?>" style="width:100%;" />
		</p>				
	<?php
	}	
}
if(!function_exists('wpo_ticket_register_widget')){
	function wpo_ticket_register_widget(){
		register_widget('WPO_ticket_quickview_widget');
	}
	add_action('widgets_init', 'wpo_ticket_register_widget');
}