<?php 
if( !defined('ABSPATH') )
	exit();
if(!class_exists('WP_List_Table')){
    require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
}
class WP_List_Table_Ticket extends WP_List_Table{
	public $table;
	public $type;
	var $per_page = 20;
	function wpdata(){
		global $wpdb;
		$table = $this->table;
		$where = "WHERE 1 AND `comment_type`='reply_ticket'";
		if($_GET['ticket']){
			$ticket = trim($_GET['ticket']);
			$where .= " AND `comment_post_ID`=$ticket";
		}
		$sql = "SELECT * FROM $table $where ORDER BY `comment_ID` DESC";
		$query = $wpdb->get_results($sql, ARRAY_A);
		return $query;
	}
    
    /** ************************************************************************
     * REQUIRED. Set up a constructor that references the parent constructor. We 
     * use the parent reference to set some default configs.
     ***************************************************************************/
    function __construct(){
        global $status, $page;
        //Set parent defaults
        parent::__construct( array(
            'singular'  => 'reply',     //singular name of the listed records
            'plural'    => 'replies',    //plural name of the listed records
            'ajax'      => true        //does this table support ajax?
        ) );
        
    }
    
    function set_table($table){
    	return $this->table = $table;
    }
    function set_type($type){
    	return $this->type = $type;
    }
    function column_default($item, $column_name){
    	switch ($column_name) {
    		case 'type':
    			return WPO_pressticket_Tickets::ticket_type($item['comment_post_ID']);
    		break;
    		case 'ticketid':
    			return wpo_ticket_get_ticketID($item['comment_post_ID']);
    		break;
    		case 'ticket':
    			return '<p><strong><a target="_blank" href="'.get_permalink($item['comment_post_ID']).'#reply-'.$item[comment_ID].'">Re: '.get_the_title($item['comment_post_ID']).'</a></strong></p>';
    		break;
    		case 'ticket_status':
    			return wpo_ticket_hightlight_status( wpo_ticket_get_ticket_status( $item['comment_post_ID'] ) );
    		break;
    		case 'author':
    			return $item['comment_author'];	
    		break;
    		case 'user':

    			if( wpo_ticket_option_envato_enable_avatar()=='yes' && get_post_meta($item['comment_post_ID'],'wpo_ticket_envato_buyer',true) && ( get_post_meta($item['comment_post_ID'],'wpo_ticket_type',true) =='envato' || get_post_meta($item['comment_post_ID'],'wpo_ticket_type',true) =='woo-envato' ) ){
					$WPO_purchasekey_verifier = new WPO_purchasekey_verifier();
					return $WPO_purchasekey_verifier->get_avatar(get_post_meta($item['comment_post_ID'],'wpo_ticket_envato_buyer',true));
				}
				else{
					$user = get_user_by('login', $item['comment_author']);
					return get_avatar($user->user_email, 64);	
				}
    		break;
    		case 'email':
    			$user = get_user_by('login', $item['comment_author']);
    			return $user->user_email;
    		break;
    		case 'department':
 				$terms = wp_get_post_terms( $item['comment_post_ID'], 'department', $args );	
				return '<span class="label">'. $terms[0]->name .'</span>';   			
    		break;
    		case 'date':
    			//return the_time($item['comment_date']) ;
    			return comment_date( 'F j, Y g:i a', $item['comment_ID'] );
    			break;
    		default:
    			return $item[$column_name];
    		break;
    	}
    }
    function column_cb($item){
        return sprintf(
            '<input type="checkbox" name="%1$s[]" value="%2$s" />',
            /*$1%s*/ $this->_args['singular'],  //Let's simply repurpose the table's singular label ("movie")
            /*$2%s*/ $item['comment_ID']                //The value of the checkbox should be the record's id
        );
    }
    function get_columns(){
    	$columns = array();
        if( current_user_can( wpo_ticket_cap_delete_ticket() ) ){
        	$columns['cb']	=	'<input type="checkbox" />';
        }
        $columns['type']	=	__('Type','wpo');
        $columns['ticketid']	=	__('Ticket ID','wpo');
        $columns['user']	=	__('User','wpo');
        $columns['email']	=	__('Email','wpo');
        $columns['department']	=	__('Department','wpo');
        $columns['ticket']	=	__('Ticket','wpo');
        $columns['ticket_status']	=	__('Status','wpo');
        //$columns['author']	=	__('Author','wpo');
        $columns['date']	=	__('Date','wpo');
        return $columns;
    }
    
    /** ************************************************************************
     * Optional. If you want one or more columns to be sortable (ASC/DESC toggle), 
     * you will need to register it here. This should return an array where the 
     * key is the column that needs to be sortable, and the value is db column to 
     * sort by. Often, the key and value will be the same, but this is not always
     * the case (as the value is a column name from the database, not the list table).
     * 
     * This method merely defines which columns should be sortable and makes them
     * clickable - it does not handle the actual sorting. You still need to detect
     * the ORDERBY and ORDER querystring variables within prepare_items() and sort
     * your data accordingly (usually by modifying your query).
     * 
     * @return array An associative array containing all the columns that should be sortable: 'slugs'=>array('data_values',bool)
     **************************************************************************/
    function get_bulk_actions() {
        $actions = array(
            'delete'    => __('Delete','wpo')
        );
        return $actions;
    }
    
    
    /** ************************************************************************
     * Optional. You can handle your bulk actions anywhere or anyhow you prefer.
     * For this example package, we will handle it in the class to keep things
     * clean and organized.
     * 
     * @see $this->prepare_items()
     **************************************************************************/
    function process_bulk_action() {
        //Detect when a bulk action is being triggered...
        if( 'delete'===$this->current_action() ) {
        	if($_GET){
        		foreach ($_GET['reply'] as $reply){
        			wp_delete_comment($reply);
        		}
        	}
        } 
    } 
    function prepare_items() {
        global $wpdb; //This is used only if making any database queries

        /**
         * First, lets decide how many records per page to show
         */
        $per_page = $this->per_page;
        
        
        /**
         * REQUIRED. Now we need to define our column headers. This includes a complete
         * array of columns to be displayed (slugs & titles), a list of columns
         * to keep hidden, and a list of columns that are sortable. Each of these
         * can be defined in another method (as we've done here) before being
         * used to build the value for our _column_headers property.
         */
        $columns = $this->get_columns();
        $hidden = array();
        $sortable = $this->get_sortable_columns();
        
        
        /**
         * REQUIRED. Finally, we build an array to be used by the class for column 
         * headers. The $this->_column_headers property takes an array which contains
         * 3 other arrays. One for all columns, one for hidden columns, and one
         * for sortable columns.
         */
        $this->_column_headers = array($columns, $hidden, $sortable);
        
        
        /**
         * Optional. You can handle your bulk actions however you see fit. In this
         * case, we'll handle them within our package just to keep things clean.
         */
        $this->process_bulk_action();
        
        
        /**
         * Instead of querying a database, we're going to fetch the example data
         * property we created for use in this plugin. This makes this example 
         * package slightly different than one you might build on your own. In 
         * this example, we'll be using array manipulation to sort and paginate 
         * our data. In a real-world implementation, you will probably want to 
         * use sort and pagination data to build a custom query instead, as you'll
         * be able to use your precisely-queried data immediately.
         */
        $data = $this->wpdata();
                   
        /***********************************************************************
         * ---------------------------------------------------------------------
         * vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
         * 
         * In a real-world situation, this is where you would place your query.
         * 
         * ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
         * ---------------------------------------------------------------------
         **********************************************************************/
        
                
        /**
         * REQUIRED for pagination. Let's figure out what page the user is currently 
         * looking at. We'll need this later, so you should always include it in 
         * your own package classes.
         */
        $current_page = $this->get_pagenum();
        
        /**
         * REQUIRED for pagination. Let's check how many items are in our data array. 
         * In real-world use, this would be the total number of items in your database, 
         * without filtering. We'll need this later, so you should always include it 
         * in your own package classes.
         */
        $total_items = count($data);
        
        
        /**
         * The WP_List_Table class does not handle pagination for us, so we need
         * to ensure that the data is trimmed to only the current page. We can use
         * array_slice() to 
         */
        $data = array_slice($data,(($current_page-1)*$per_page),$per_page);
        
        
        
        /**
         * REQUIRED. Now we can add our *sorted* data to the items property, where 
         * it can be used by the rest of the class.
         */
        $this->items = $data;
        
        
        /**
         * REQUIRED. We also have to register our pagination options & calculations.
         */
        $this->set_pagination_args( array(
            'total_items' => $total_items,                  //WE have to calculate the total number of items
            'per_page'    => $per_page,                     //WE have to determine how many items to show on a page
            'total_pages' => ceil($total_items/$per_page)   //WE have to calculate the total number of pages
        ) );
    }
    
}