<?php
error_reporting(0);
set_time_limit(0);
if( !ABSPATH )
	exit();
/**
 * Plugin Name: PressTicket Client
 * Author: Toan Nguyen
 * Author URI: http://wpoffice.net/contact/
 * Version: 1.0
 * Plugin URI: http://pressticket.com
 * Description: The PressTicket plugin for Client site.
 */
if( !defined('WPO_PRESSTICKET_CLIENT_URL') )
	define('WPO_PRESSTICKET_CLIENT_URL', plugin_dir_url(__FILE__));
if( !class_exists('WPO_pressticket_ClientSide') ){
	class WPO_pressticket_ClientSide {
		var $priority = 1;
		var $icon_16 = NULL;
		var $icon_32 = null;
		var $config_file = 'config.json';
		var $SSL = false;
		function __construct(){
			add_action('admin_menu', array($this,'add_menu_page'));
			add_action('admin_enqueue_scripts', array($this,'wp_enqueue_style'));
			add_filter('pressticket_client_beforeform', array($this,'pressticket_client_beforeform'));
			add_filter('pressticket_client_afterform', array($this,'pressticket_client_afterform'));
			add_filter('pressticket_client_settings_beforeform', array($this,'pressticket_client_settings_beforeform'));
			add_action('wp_ajax_openticket', array($this,'ajax_createticket'));
			add_action('wp_ajax_send_ticket_response', array($this,'ajax_send_ticket_response'));
			add_action('init', array($this,'save_settings'));
			add_action('admin_notices', array($this,'new_response_created'));
			add_action('admin_notices', array($this,'new_ticket_created'));
			add_action('admin_notices', array($this,'wrong_user_wpi'));
			add_action('plugins_loaded', array($this,'load_language'));
		}
		function load_language(){
			load_plugin_textdomain('wpo',false,dirname( plugin_basename( __FILE__ ) ) . '/language');
		}
		function wp_enqueue_style(){
			$form_settings = $this->get_config();
			wp_enqueue_style('press-ticket-client-style', plugin_dir_url(__FILE__) . 'asset/css/style.css');
			wp_enqueue_script('press-ticket-client-script', plugin_dir_url(__FILE__) . 'asset/js/script.js');
		}
		function set_icon($size=16){
			return $this->icon_ . $size = plugin_dir_url(__FILE__) . 'asset/img/icon_helpdesk_'.$size.'.png'; 
		}
		function new_ticket_created(){
			if( isset( $_GET['new_ticket_created'] ) ){
				if( $_GET['new_ticket_created']=='yes' ){
					_e('<div class="updated"><p>New ticket was created successfully, Our Support Staff will reply You as soon as possible.<br/>Thank You!</p></div>','wpo');
				}
			}
		}
		function new_response_created(){
			if( isset( $_GET['new_response_created'] ) ){
				if( $_GET['new_response_created']=='yes' ){
					_e('<div class="updated"><p>New message appended to ticket, Our Support Staff will reply You as soon as possible.<br/>Thank You!</p></div>','wpo');
				}
			}			
		}
		function wrong_user_wpi(){
			$settings = $this->get_settings();
			$form_settings = $this->get_config();
			$apiurl = $form_settings['apiurl'];
			$username = $settings->username ? $settings->username : null;
			$apikey = $settings->apikey ? $settings->apikey : null;
			$data =  (array)json_decode($this->curl($apiurl,1,'action=verifymy&username='.$username.'&apikey='.$apikey) );
			if( $data['resp']=='error' ){
				$message = sprintf( __('This is the message from %s: ','wpo') , '<a href="'.$form_settings['homepage'].'">'.$form_settings['brandname'].'</a>') . '<strong>'. $data['message'] .'</strong>';
				_e('<div class="updated"><p>'.$message.'</p></div>','wpo');
			}
		}
		function get_config(){
			if( !function_exists('curl_version') )
				return false;
			$data = $this->curl( plugin_dir_url(__FILE__) . '/' . $this->config_file );
			$data = (array)json_decode( $data );
			return $data;
		}
		function curl($url, $post = 0, $string = NULL){
			if( !function_exists('curl_version') )
				return false;
			$ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
            curl_setopt($ch, CURLOPT_POST, $post);
            if( $post == 1 && $string ){
            	curl_setopt($ch, CURLOPT_POSTFIELDS, $string );
            }
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT ,400); 
			curl_setopt($ch, CURLOPT_TIMEOUT, 400); //timeout in seconds
            $data = curl_exec($ch);
            curl_close($ch);
            return $data;
		}
		function add_menu_page(){
			$form_settings = $this->get_config();
			$menu_title = trim( $form_settings['menu_title'] ) ? trim( $form_settings['menu_title'] ) : __('PressTicket','wpo');
			$page_title = trim( $form_settings['page_title'] ) ? trim( $form_settings['page_title'] ) : __('PressTicket','wpo'); 
			add_menu_page($page_title, $menu_title, 'add_users', 'wpo-pressticket-client', array($this,'showform'), $this->set_icon() ,$this->priority);
		}
		function showtabs($single=false){
			$tab = null;
			$tabs = array(
				''	=>	__('Open Ticket','wpo'),
				'tickets'	=>	__('All Tickets','wpo'),
				'settings'	=>	__('Settings','wpo')
			);
			if ( $single === true )
				return $tabs[$_GET['tab']];
			foreach ($tabs as $k=>$v){
				$current_tab = ($_GET['tab']==$k) ? 'nav-tab-active' : NULL;
				$tab .= '<a href="'.admin_url('admin.php?page=wpo-pressticket-client').'&tab='.$k.'" class="nav-tab '.$current_tab.'">'.$v.'</a>';
			}
			return $tab;
		}
		function showform() {
			$current_tab = trim( $_GET['tab'] );
			$form_settings = $this->get_config();
			//print_r($form_settings);
			$head_title = trim( $form_settings['page_title'] ) ? trim( $form_settings['page_title'] ) :  __('PressTicket','wpo');
			$homepage = trim( $form_settings['homepage'] ) ? trim( $form_settings['homepage'] ) :  null;
			$html = null;
			$html .= '<div class="wrap">';
				$html .= '<div id="icon-options-general" class="icon32"><br></div>';
				$html .= '<h2>'.$head_title.'</h2>';
				if( $form_settings['logo'] ){
					$html .= '<div class="pressticket-header">';
						$html .= '<img style="width: 70px;height:auto;" src="'.$form_settings['logo'].'">';
					$html .= '</div>';
				}
				$html .= '<h2 class="nav-tab-wrapper">' . $this->showtabs() . '</h2>';
				$html .= '<h2>'. $this->showtabs(true)  .'</h2>';
					if( $current_tab=='' || empty( $current_tab ) ):
							if( $is_logged['resp']!='error' ){
								$html .= $this->show_ticketform($form_settings);		
							}
							else{
								$html .= $this->show_loginform();
							}
					elseif ( $current_tab =='tickets' ):
						$html .= $this->getposts();		
					elseif ( $current_tab =='settings' ):
						$html .= $this->show_settings();
					endif;
				$html .= '</h2>';
			$html .= '</div>';
			print $html;
		}
		function show_ticketform($form_settings){
			$form = null;
			$visualeditor = ($form_settings['visualeditor'] == 'on') ? true : false;
			$form .= apply_filters('pressticket_client_beforeform', null);
			$form .= '<form class="press-ticket-client ticket-form" id="press-ticket-client" name="press-ticket-client">';
				$form .= '<table class="form-table"><tbody>';
					if( is_object( $form_settings['department'] ) ){
						$form .= '<tr valign="top">';
							$form .= '<th scope="row"><label>'.__('Department','wpo').'</label></th>';
							$form .= '<td>'. $this->get_selectfield( $form_settings['department'], 'ticket_data[department]' ) . '</td>';
						$form .= '</tr>';
					}
					
					if( is_object( $form_settings['priority'] ) ){
						$form .= '<tr valign="top">';
							$form .= '<th scope="row"><label>'.__('Priority','wpo').'</label></th>';
							$form .= '<td>'. $this->get_selectfield( $form_settings['priority'], 'ticket_data[priority]' ) . '</td>';
						$form .= '</tr>';						
					}
					
					if( is_object( $form_settings['status'] ) ){
						$form .= '<tr valign="top">';
							$form .= '<th scope="row"><label>'.__('Status','wpo').'</label></th>';
							$form .= '<td>'. $this->get_selectfield( $form_settings['status'], 'ticket_data[status]' ) . '</td>';
						$form .= '</tr>';						
					}
					### Ticket subject
					$form .= '<tr valign="top">';
						$form .= '<th scope="row"><label>'.__('Subject: Issue summary *','wpo').'</label></th>';
						$form .= '<td><input type="text" name="ticket_data[subject]" class="regular-text"></td>';
					$form .= '</tr>';	
					$form .= '<tr valign="top">';
						$form .= '<th colspan=2 scope="row"><label>'.__('Issue: Details on the reason(s) for opening the ticket. *','wpo').'</label></th>';
					$form .= '</tr>';										
					$form .= '<tr valign="top">';
						//$form .= '<th scope="row"><label>'.__('Issue: Details on the reason(s) for opening the ticket. *','wpo').'</label></th>';
						$form .= '<td colspan=2>'.$this->get_editor('', 'content', 'ticket_data[content]', true, $visualeditor).'</td>';
					$form .= '</tr>';	
					$form .= '<tr valign="top"><td colspan=2><p class="submit">
						<input type="hidden" name="page" value="wpo-pressticket-client">
						<input type="hidden" name="action" value="openticket">
						<input type="submit" name="submit" id="submit" class="button button-primary" value="'.__('Open the Ticket','wpo').'">
						<img style="display:none" src="'.WPO_PRESSTICKET_CLIENT_URL.'asset/img/loading.gif" id="loading">
					</p></td></tr>';					
				$form .= '<tbody></table>';
			$form .= '</form>';
			$form .= apply_filters('pressticket_client_afterform', null);
			return $form;
		}
		function show_settings(){
			$settings = $this->get_settings();
			$username = $settings->username ? $settings->username : null;
			$apikey = $settings->apikey ? $settings->apikey : null;
			$form = null;
			$form .= apply_filters('pressticket_client_settings_beforeform', null);
			$form .= '<form method="post" action="" class="press-ticket-client" name="press-ticket-client-settings">';
				$form .= '<table class="form-table"><tbody>';
					$form .= '<tr valign="top">';
						$form .= '<th scope="row"><label>'.__('Your Username','wpo').'</label></th>';
						$form .= '<td><input value="'.$username.'" type="text" name="pressticket[username]" class="regular-text"></td>';
					$form .= '</tr>';
					$form .= '<tr valign="top">';
						$form .= '<th scope="row"><label>'.__('Your APIKEY (<i>Will not be shown</i>)','wpo').'</label></th>';
						$form .= '<td><input value="'.$apikey.'" type="text" name="pressticket[apikey]" class="regular-text"></td>';
					$form .= '</tr>';	
					$form .= '<tr valign="top"><td colspan=2><p class="submit">
						<input type="hidden" name="page" value="wpo-pressticket-client">
						<input type="hidden" name="tab" value="settings">
						<input type="hidden" name="action" value="createticket_settings">
						<input type="submit" name="submit" id="submit" class="button button-primary" value="'.__('Save Settings','wpo').'">
					</p></td></tr>';
				$form .= '</tbody></table>';
			$form .= wp_nonce_field('createticket_settings_act','createticket_settings',false);
			$form .= '</form>';
			$form .= apply_filters('pressticket_client_settings_afterform', null);
			return $form;
		}
		function save_settings(){
			if( is_admin() && wp_verify_nonce($_POST['createticket_settings'],'createticket_settings_act') ){
				$settings = $_POST['pressticket'];
				update_option('pressticket_clientinfo',  base64_encode( json_encode( $settings ) ) );
			}
		}
		/**
		 * Get Username and Password
		 */
		function get_settings(){
			$settings = get_option('pressticket_clientinfo');
			if( !$settings || empty( $settings ) )
				return FALSE;
			$settings = json_decode( base64_decode( $settings ) );
			return $settings;
		}
		function ajax_createticket(){
			$settings = $this->get_settings();
			$form_settings = $this->get_config();
			//$apiurl = trim( $form_settings['apiurl'] ) ? $form_settings['apiurl'] : null;
			$apiurl = $form_settings['apiurl'];
			$postdata = $_POST['ticket_data'];
			$data = array(
				'action'	=>	$_POST['action'],
				'department'	=>	$postdata['department'],
				'priority'	=>	$postdata['priority'],
				'status'	=>	$postdata['status'] ? $postdata['status'] : 'open',
				'subject'	=>	stripslashes($postdata['subject']),
				'content'	=>	stripslashes($postdata['content']),
				'username'	=>	$settings->username,
				'apikey'	=>	$settings->apikey
			);
			if( !is_admin() )
				return;
			if( empty( $settings ) ){
				echo json_encode(array(
					'resp'	=>	'error',
					'mess'	=>	__('We did not find the Info as Username, API Key to proccess this request, Please contact your Support Center Administrator','wpo')
				));exit;				
			}
			$username = $settings->username ? $settings->username : null;
			$apikey = $settings->apikey ? $settings->apikey : null;
			if( empty( $username ) ){
				echo json_encode(array(
					'resp'	=>	'error',
					'mess'	=>	__('We did not find the Username or Invalid Username to proccess this request, Please contact your Support Center Administrator','wpo')
				));exit;				
			}
			
			if( empty( $apikey ) ){
				echo json_encode(array(
					'resp'	=>	'error',
					'mess'	=>	__('We did not find your API Key to proccess this request, Please contact your Support Center Administrator','wpo')
				));exit;				
			}
			### check required
			if( !$apiurl ){
				echo json_encode(array(
					'resp'	=>	'error',
					'mess'	=>	__('We did not find API url to proccess this request, Please contact your Support Center Administrator','wpo')
				));exit;
			}
			if( !$data['subject'] ){
				echo json_encode(array(
					'resp'	=>	'error',
					'mess'	=>	__('Please enter subject, Issue summary!','wpo')
				));exit;
			}
			if( !$data['content'] ){
				echo json_encode(array(
					'resp'	=>	'error',
					'mess'	=>	__('Please enter issue, Details on the reason(s) for opening the ticket. * !','wpo')
				));exit;
			}
			foreach ( $data as $key => $value) {
			    $post_items[] = $key . '=' . $value;
			}
			
			$string = implode ('&', $post_items);
			//echo  json_encode($string) ;exit;
			$data = (array)json_decode( $this->curl( $apiurl, 1, $string) );
			if( $data['resp']=='success' ){
				echo json_encode(array(
					'resp'	=>	'success',
					'mess'	=>	$data['message'],
					'ticket_client_url'	=>	admin_url('admin.php?page=wpo-pressticket-client&tab=tickets&ticketid='.$data['data']->ticket_id . '&new_ticket_created=yes')
				));exit;
			}
			else{
				echo json_encode(array(
					'resp'	=>	'error',
					'mess'	=>	$data['message']
				));
				exit;
			}
			exit;
		}
		function ajax_send_ticket_response(){
			$settings = $this->get_settings();
			$form_settings = $this->get_config();
			//$apiurl = trim( $form_settings['apiurl'] ) ? $form_settings['apiurl'] : null;
			$apiurl = $form_settings['apiurl'];
			$username = $settings->username ? $settings->username : null;
			$apikey = $settings->apikey ? $settings->apikey : null;
			$data = array();
			$postdata = $_POST['data'];
			if( empty( $username ) ){
				echo json_encode(array(
					'resp'	=>	'error',
					'mess'	=>	__('We did not find the Username or Invalid Username to proccess this request, Please contact your Support Center Administrator','wpo')
				));exit;				
			}
			if( empty( $apikey ) ){
				echo json_encode(array(
					'resp'	=>	'error',
					'mess'	=>	__('We did not find your API Key to proccess this request, Please contact your Support Center Administrator','wpo')
				));exit;				
			}
			if( trim( $postdata['response_content'] ) =='' ){
				echo json_encode(array(
					'resp'	=>	'error',
					'mess'	=>	__('Please enter the Response Content','wpo')
				));exit;
			}
			$data = array(
				'action'	=>	$postdata['action'],
				'response_content'	=>	stripslashes($postdata['response_content']),
				'status'	=>	$postdata['status'],
				'ticketid'	=>	$postdata['ticketid'],
				'username'	=>	$settings->username,
				'apikey'	=>	$settings->apikey
			);
			foreach ( $data as $key => $value) {
			    $post_items[] = $key . '=' . $value;
			}
			$string = implode ('&', $post_items);			
			$data =  (array)json_decode($this->curl($apiurl,1,$string) );
			if( $data['resp']=='success' ){
				echo json_encode(array(
					'resp'	=>	'success',
					'mess'	=>	$data['message'],
					'ticket_client_url'	=>	admin_url('admin.php?page=wpo-pressticket-client&tab=tickets&ticketid='. $postdata['ticketid'] . '&new_response_created=yes')
				));
				exit;				
			}
			else{
				echo json_encode(array(
					'resp'	=>	'error',
					'mess'	=>	$data['message']
				));
				exit;
			}
			exit;			
		}
		function getposts(){
			$s = isset( $_GET['s'] ) ? trim( $_GET['s'] ) : NULL;
			$offset = isset( $_GET['offset'] ) ? trim( $_GET['offset'] ) : 0;
			$status = isset( $_GET['status'] ) ? trim( $_GET['status'] ) : null;
			$priority = isset( $_GET['priority'] ) ? trim( $_GET['priority'] ) : null;
			$ticketid = isset( $_GET['ticketid'] ) ? trim( $_GET['ticketid'] ) : null;
			$html = null;
			$settings = $this->get_settings();
			$form_settings = $this->get_config();
			//$apiurl = trim( $form_settings['apiurl'] ) ? $form_settings['apiurl'] : null;
			$apiurl = $form_settings['apiurl'];
			$username = $settings->username ? $settings->username : null;
			$apikey = $settings->apikey ? $settings->apikey : null;
			$data =  (array)json_decode($this->curl($apiurl,1,'action=getposts&s='.$s.'&username='.$username.'&apikey='.$apikey.'&offset='.$offset.'&status='.$status.'&priority='.$priority) );
			$html .= '			
				<form id="posts-filter" class="tiket-filter">
					<p class="search-box">
						<label class="screen-reader-text" for="post-search-input">'.__('Search Tickets','wpo').':</label>
						<input type="hidden" name="page" value="wpo-pressticket-client">
						<input type="hidden" name="tab" value="tickets">
						<input type="search" id="post-search-input" name="s" value="'. $s .'" placeholder="'.__('#Ticket ID','wpo').'">
						'.$this->get_selectfield( $form_settings['status'], 'status' ).'
						'.$this->get_selectfield( $form_settings['priority'], 'priority' ).'
						<input type="submit" name="" id="search-submit" class="button" value="'.__('Search Tickets','wpo').'">
					</p>
				</form>
			';
			if( !$ticketid ):
			$html .= '<table class="form-table ticket-list" cellspacing="0">';
				$html .= '
					<thead><tr>
						<th scope="col">'.__('Ticket ID','wpo').'</th>
						<th scope="col">'.__('Issue','wpo').'</th>
						<th scope="col">'.__('Priority','wpo').'</th>
						<th scope="col">'.__('Status','wpo').'</th>
						<th scope="col">'.__('Department','wpo').'</th>
						<th scope="col">'.__('Helptopic','wpo').'</th>
						<th scope="col">'.__('Date','wpo').'</th>
					</tr></thead></tbody>
				';
				if( $data['data'] ){
					$i = 0;
					foreach ( $data['data'] as $ticket ){
						$i++;
						$class = ( $i%2!=0 ) ? 'first' : 'second';
						$html .= '
							<tr class="row '.$class.'">
								<td><a target="_blank" href="'.$ticket->ticket_url.'">'.$ticket->ticket_id.'</a></td>
								<td>
									<a href="'.admin_url('admin.php?page=wpo-pressticket-client&tab=tickets&ticketid='.$ticket->ticket_id ).'">'.$ticket->ticket_title.'</a>';
								if( $ticket->ticket_response_number > 1 ){
									$html .=  sprintf( __('<div><i>%s responses</i></div>') , $ticket->ticket_response_number) ;
								}
								else{
									$html .=  sprintf( __('<div><i>%s response</i></div>') , $ticket->ticket_response_number) ;
								}
								$html .= '	
								</td>
								<td><label class="label ticket-meta '.$ticket->ticket_priority_key.'">'.$ticket->ticket_priority.'</label></td>
								<td><label class="label ticket-meta '.$ticket->ticket_status_key.'">'.$ticket->ticket_status.'</label></td>';
								if( $ticket->ticket_department ){
									$html .= '<td><label class="label ticket-meta '.$ticket->ticket_department.'">'.$ticket->ticket_department.'</label></td>';	
								}
								else{
									$html .= '<td></td>';
								}
								if( $ticket->ticket_helptopic ){
									$html .= '<td><label class="label ticket-meta '.$ticket->ticket_helptopic.'">'.$ticket->ticket_helptopic.'</label></td>';	
								}
								else{
									$html .= '<td></td>';
								}
								$html .= '
								
								<td><label class="ticket-meta date"><abbr>'.date('F j, Y',strtotime($ticket->ticket_date)).'</abbr></label></td>
							</tr>
						';
					}
				}
				else{
					$html .= '<tr><td style="text-align:center;" colspan=7>'.__('We found no Ticket on this page. Please refine your search criteria.','wpo').'</td></tr>';
				}
			$html .= '</tbody></table>';
			if( !isset( $_GET['offset'] ) || $_GET['offset'] == 0 ){
				$html .= '<a href="'.admin_url('admin.php?page=wpo-pressticket-client&tab=tickets&offset='.$ticket->offset .'&status='.$_GET['status'] .'&priority='.$_GET['priority']).'" offset="'.$ticket->offset.'" order="'.$ticket->ticket_order.'" orderby="'.$ticket->ticket_orderby.'" class="button button-primary button-large loadmore">'.__('Next >>','wpo').'</a>';	
			}
			else{
				$back = (int)$_GET['offset'] - ( $ticket->posts_per_page ? $ticket->posts_per_page : 20 );
				$html .='<ul class="pagnation">';
				$html .= '<li><a href="'.admin_url('admin.php?page=wpo-pressticket-client&tab=tickets&offset='. $back .'&status='.$_GET['status'] .'&priority='.$_GET['priority']).'" offset="'.$ticket->offset.'" order="'.$ticket->ticket_order.'" orderby="'.$ticket->ticket_orderby.'" class="button button-primary button-large loadmore">'.__('<< Back','wpo').'</a></li>';
				$html .= '<li><a href="'.admin_url('admin.php?page=wpo-pressticket-client&tab=tickets&offset='.$ticket->offset .'&status='.$_GET['status'] .'&priority='.$_GET['priority']).'" offset="'.$ticket->offset.'" order="'.$ticket->ticket_order.'" orderby="'.$ticket->ticket_orderby.'" class="button button-primary button-large loadmore">'.__('Next >>','wpo').'</a></li>';
				$html .= '</ul>';
			}
			elseif ( $ticketid!='' ):
				$html .= $this->getpost($ticketid);
			endif;
			return $html;
		}
		function getpost($ticketid){
			$html = '<div class="ticket-content">';
			$settings = $this->get_settings();
			$form_settings = $this->get_config();
			$apiurl = $form_settings['apiurl'];
			$username = $settings->username ? $settings->username : null;
			$apikey = $settings->apikey ? $settings->apikey : null;
			$data =  (array)json_decode($this->curl($apiurl,1,'action=getpost&ticketid='.$ticketid.'&username='.$username.'&apikey='.$apikey) );
			if( $data['data'] ){
				$html .= '<div class="title"><h4>' . __('Issue Subject: ','wpo').'</h4></div>';
				$html .= '<h3><a href="'.$data['data']->ticket_url.'">' . $data['data']->ticket_title .'</a></h3>';
				$html .= '<div class="opendate ticketmeta">'.__('Date: ','wpo').' <label class="label label-warning">'.date('F j, Y',strtotime($data['data']->ticket_date)).'</label></div>';
				$html .= '<div class="status ticketmeta">'.__('Status: ','wpo').' <label class="label label-warning '.$data['data']->ticket_status_key.'">'.$data['data']->ticket_status.'</label></div>';
				$html .= '<div class="priority ticketmeta">'.__('Priority: ','wpo').' <label class="label label-warning '.$data['data']->ticket_status_key.'">'.$data['data']->ticket_priority.'</label></div>';
				$html .= '<div class="department ticketmeta">'.__('Department: ','wpo').' <label class="label label-warning '.$data['data']->ticket_department.'">'.$data['data']->ticket_department.'</label></div>';
				$html .= '<div class="ticketid ticketmeta">'.__('Ticket ID: ','wpo').' <label class="label label-warning '.$data['data']->ticket_id.'">'.$data['data']->ticket_id.'</label></div>';
				$html .= '<h4>'.__('Issue Content: ').'</h4>';
				$html .= '<div class="content">'. nl2br( $data['data']->ticket_content ) .'</div>';
				$html .= '<div class="responses-list">';
					$html .= $this->getresponses($ticketid);
				$html .= '</div>';
				if( $data['data']->ticket_status_key == 'open' ){
					$html .= '<form action="" method="post" name="ticket-send-response" class="ticket-form">';
					$html .= '<div class="responses-form">'.$this->get_editor(null, 'response_content', 'data[response_content]').'</div>';
					if( is_object( $form_settings['status'] ) ){
						$html .= '<table class="form-table"><tbody><tr valign="top">';
							$html .= '<td>'. $this->get_selectfield( $form_settings['status'], 'data[status]' ) . '</td>';
						$html .= '</tr></tbody></table>';						
					}					
					$html .= '<p class="submit">
						<input type="hidden" name="data[action]" value="sendresponse">
						<input type="hidden" name="action" value="send_ticket_response">
						<input type="hidden" name="data[ticketid]" value="'.trim( $_GET['ticketid'] ).'">
						<input type="submit" name="submit" id="submit" class="button button-primary" value="'.__('Send Response','wpo').'">
						<img style="display:none;" id="loading" src="'.WPO_PRESSTICKET_CLIENT_URL.'asset/img/loading.gif">
					</p>
					';
					$html .= '</form>';	
				}
				else{
					$html .= '<div class="alert noted ticket-status"><p>'. sprintf( __('%s ticket','wpo'),$data['data']->ticket_status) .'</p></div>';
				}
			}
			$html .= '</div>';
			return $html;
			
		}
		/**
		 * Get all response of the Ticket
		 */
		function getresponses($ticketid){
			$form_settings = $this->get_config();
			$html = '<div class="ticket-content">';
			$settings = $this->get_settings();
			$apiurl = $form_settings['apiurl'];
			$username = $settings->username ? $settings->username : null;
			$apikey = $settings->apikey ? $settings->apikey : null;
			$data =  (array)json_decode($this->curl($apiurl,1,'action=getresponses&ticketid='.$ticketid.'&username='.$username.'&apikey='.$apikey) );
			if( $data['data'] ){
				$i = 0;
				$html .= '<h3>'.__('All the response for this Ticket','wpo').'</h3>';
				$html .= '<table class="table table-hover form-table responses-list"><tbody>';
					foreach ( $data['data'] as $response ){
						$i++;
						$class = ( $i%2!=0 ) ? 'first' : 'second';						
						$html .= '
							<tr class="row '.$class.'">
								<td style="width: 15%;text-align:center">
									'.$response->response_avatar.'
									<div>'.$response->response_author.'</div>';
								if( $response->response_author == $username ){
									$html .= '<div>'.__('You','wpo').'</div>';
								}			
								else{
									$html .= '<div>'.__('Support Staff','wpo').'</div>';
								}
								$html .= '</td>
								<td style="vertical-align:top;">
								'.nl2br( $response->response_content ).'
								<div>'.date('F j, Y',strtotime($response->response_date)).'</div>
								</td>
							</tr>
						';
					}
				$html .= '</tbody></table>';
			}
			else{
				$html .= '<h3>'.__('No Response','wpo').'</h3>';	
			}
			return $html;
		}
		/**
		 * Get detail response, know as comment.
		 * @param unknown_type $response_id
		 */
		function getresponse($response_id){
			
		}
		function pressticket_client_beforeform(){
			$form_settings = $this->get_config();
			if( $form_settings['beforeform'] ){
				return '<div class="ptext" id="pressticket_client_beforeform">'.$form_settings['beforeform'].'</div>';
			}
		}
		function pressticket_client_afterform(){
			$form_settings = $this->get_config();
			if( $form_settings['afterform'] ){
				return '<div class="ptext" id="pressticket_client_afterform">'.$form_settings['afterform'].'</div>';
			}
		}
		function pressticket_client_settings_beforeform(){
			$form_settings = $this->get_config();
			$homepage = $form_settings['homepage'] ? $form_settings['homepage'] : 'http://wpoffice.net';
			$brandname = $form_settings['brandname'] ? $form_settings['brandname'] : 'PressTicket System';
			$text = sprintf( __('<p>This Account and APIkey will be provided by %s</p>','wpo') ,'<a href="'.$homepage.'">'.$brandname.'</a>'); 
			return $text;
		}
		function get_selectfield($field_obj,$fieldname=NULL ){
			$html = null;
			if( !is_object( $field_obj ) )
				return;
			$html .= '<select name="'.$fieldname.'" class="regular-text select">';
				$html .= '<option value="0">'.__('Choose one ...','wpo').'</option>';
			foreach ($field_obj as $key=>$value){
				if( $_GET[$fieldname]==$key ){
					$selected = 'selected';
				}
				else{
					$selected = null;
				}
				$html .= '<option '.$selected.' value="'.$key.'">'.$value.'</option>';
			}
			$html .= '</select>';
			return $html;
		}
		function get_editor($content, $id, $name, $media = true, $visual=true) {
			if( $visual!==true )
				return '<textarea style="width: 50em;height:10em;" class="regular-text" name="'.$name.'"></textarea>';
			// Turn on the output buffer
			ob_start();
			$settings = array(
				'textarea_name' => $name,
				'media_buttons' => $media,
				'quicktags'	=>	false,
				'textarea_rows'	=>	10
			);
			wp_editor($content,$id, $settings);
			$editor_contents = ob_get_clean();
			return $editor_contents;			
		}
	}
	$WPO_pressticket_ClientSide = new WPO_pressticket_ClientSide();
}