<?php
if( !defined('ABSPATH') )
	exit();
if( !function_exists('wpo_ticket_createticket') ){
	function wpo_ticket_createticket(){
		if(class_exists('WPO_purchasekey_verifier')){
			$WPO_purchasekey_verifier = new WPO_purchasekey_verifier();
		}
		if( $_POST ){
			if( !get_current_user_id() ){
				echo json_encode(array('resp'=>'error','mess'=>__('Please login to use this feature!','wpo')));exit;
			}
			if( !current_user_can( wpo_ticket_cap_view_ticket() ) ){
				echo json_encode(array('resp'=>'error','mess'=>__('You do not have permission to use this feature!','wpo')));exit;
			}
			if( wpo_ticket_check_limit_ticketbox(get_current_user_id())===FALSE ){
				echo json_encode(array('resp'=>'error','mess'=>__('Your ticketbox is over our\'s quota limit!','wpo')));exit;
			}
			$department = trim($_POST['department']);
			$priority = trim($_POST['priority']);
			$status = trim($_POST['status']);
			$subject = trim(strip_tags($_POST['subject']));
			$post_content = trim($_POST['post_content']);
			$helptopics = trim($_POST['helptopics']);
			$product_id = (int)$_POST['product'] ? (int)$_POST['product'] : 0;
			if(!$department || $department==''){
				echo json_encode(array('resp'=>'error','mess'=>__('Please choose Department','wpo')));exit();
			}
			if(!$subject){
				echo json_encode(array('resp'=>'error','mess'=>__('Please enter subject, Issue summary!','wpo')));exit();
			}
			### check if Envato integrated.
			if( wpo_ticket_option_envato_enable()=='yes' && $_POST['envato_purchasekey']=='required' ){
				$purchase_key = trim( $_POST['envato_purchase_key'] );
				$envato_account = trim( $_POST['envato_account'] );
				if( $purchase_key == ''  ){
					echo json_encode(array('resp'=>'error','mess'=>__('Please enter your Envato Purchase Key','wpo')));exit;
				}
				if( $envato_account == ''  ){
					echo json_encode(array('resp'=>'error','mess'=>__('Please enter your Envato Account','wpo')));exit;
				}				
				if( !empty( $purchase_key ) ){
					$purchase_key_verify = $WPO_purchasekey_verifier->verifier($purchase_key);	
					if( $purchase_key_verify['resp'] =='error' ){
						echo json_encode(array('resp'=>'error','mess'=>$purchase_key_verify['mess']));exit();	
					}
					if( $purchase_key_verify['buyer'] != $envato_account ){
						echo json_encode(array('resp'=>'error','mess'=> __('You\'re not the buyer of this Purchase key','wpo') ));exit();
					}
				}
			}
			if(!$post_content){
				echo json_encode(array('resp'=>'error','mess'=>__('Please enter issue, Details on the reason(s) for opening the ticket. * !','wpo')));exit();
			}
			if( wpo_ticket_check_enable_recaptcha() === TRUE && function_exists('recaptcha_check_answer')){
				# the response from reCAPTCHA
				$resp = null;
				# the error code from reCAPTCHA, if any
				$error = null;				
				$resp = recaptcha_check_answer (wpo_ticket_option_recaptcha_private_key(),
                                        $_SERVER["REMOTE_ADDR"],
                                        $_POST["recaptcha_challenge_field"],
                                        $_POST["recaptcha_response_field"]);
			
		        if (!$resp->is_valid){
		        	echo json_encode(array('resp'=>'error','mess'=>$resp->error));exit();
		        }	        	
			}
			### insert ticket
			$post_id = wp_insert_post(array(
				'post_title'	=>	$subject,
				'post_content'	=>	$post_content,
				'post_author'	=>	get_current_user_id(),
				'post_type'	=> 'wp-ticket',
				'post_status'	=>	'publish',
				'comment_status'	=>	'closed'
			));
			if($post_id>0){
				### set taxonomy
				wp_set_post_terms($post_id,$department,'department',true);
				update_post_meta($post_id, 'wpo_ticket_priority', $priority);
				update_post_meta($post_id, 'wpo_ticket_status', $status);
				update_post_meta($post_id, 'wpo_ticket_helptopics', $helptopics);
				### Add Related Product
				if( $product_id > 0 ){
					update_post_meta($post_id, 'wpo_ticket_related_product', $product_id);
				}
				### check Envato Integrated
				if( $purchase_key_verify['resp'] == 'success' ){
					update_post_meta($post_id, 'wpo_ticket_envato_purchase_key', $purchase_key);
					update_post_meta($post_id, 'wpo_ticket_envato_item_name', $purchase_key_verify['item_name']);
					update_post_meta($post_id, 'wpo_ticket_envato_item_id', $purchase_key_verify['item_id']);
					update_post_meta($post_id, 'wpo_ticket_envato_created_at', $purchase_key_verify['created_at']);
					update_post_meta($post_id, 'wpo_ticket_envato_buyer', $purchase_key_verify['buyer']);
					update_post_meta($post_id, 'wpo_ticket_envato_licence', $purchase_key_verify['licence']);
				}
				### update ticket type as woo, envato or wp default
				if( $product_id > 0 && $purchase_key ){
					update_post_meta($post_id, 'wpo_ticket_type', 'woo-envato');
				}
				elseif($product_id > 0){
					update_post_meta($post_id, 'wpo_ticket_type', 'woo');
				}
				elseif( !empty( $purchase_key ) ){
					update_post_meta($post_id, 'wpo_ticket_type', 'envato');
				}
				else{
					update_post_meta($post_id, 'wpo_ticket_type', 'wp');
				}
				do_action('pressticket_add_ticket', $post_id,$department);
				echo json_encode(array('resp'=>'success','mess'=>__('Open ticket successfully','wpo'),'url_ticket'=>get_permalink($post_id)));exit();
			}			
		}
		else{
			echo json_encode(array('resp'=>'error','mess'=>__('Error, please try again!','wpo')));exit();
		}
	}
	add_action('wp_ajax_createticket', 'wpo_ticket_createticket');
	add_action('wp_ajax_nopriv_createticket', 'wpo_ticket_createticket');
}
if(!function_exists('wpo_ticket_ajax_department_get_helptopic')){
	/**
	 * Ajax get dropdown Helptopic
	 */
	function wpo_ticket_ajax_department_get_helptopic() {
		if(get_current_user_id()){
			$department_id = (int)$_POST['department_id'];
			$area = isset( $_POST['area'] ) ? $_POST['area'] : null;
			$html = '';
			if($department_id > 0){
				### call to get helptopics
				$helptopics = wpo_ticket_get_helptopics($department_id);
				if(is_array($helptopics)){
					if( $area == null ):
					$html .= '<div class="control-group helptopics">
								<label class="control-label" for="Help Topics">'.__('Help Topics','wpo').'</label>
								<div class="controls">';
						$html .= '<select name="helptopics" class="helptopics">';
							for ($i=0;$i<count($helptopics);$i++){
								$html .= '
									<option value="'.$helptopics[$i].'">'.$helptopics[$i].'</option>
								';
							}
						$html .= '</select>';
					$html .= '</div></div>';
					else:
						### return html option
						for ($i=0;$i<count($helptopics);$i++){
							$html .= '
								<option value="'.$helptopics[$i].'">'.$helptopics[$i].'</option>
							';
						}						
					endif;
				}
			}
		}
		echo $html;exit();
	}
	add_action('wp_ajax_department_get_helptopic', 'wpo_ticket_ajax_department_get_helptopic');
}
if(!function_exists('wpo_ticket_ajax_replyticket')){
	function wpo_ticket_ajax_replyticket() {
		$users = get_user_by('id', get_current_user_id());
		$post_id = (int)$_POST['post_id'];
		$response_content = trim($_POST['reply_content']);
		$status = trim($_POST['status']);
		### check if this is author or admin, who can reply
		if( get_post_meta($post_id,'wpo_ticket_status',true)=='close' ){
			echo json_encode(array(
				'resp'	=>	'error',
				'mess'	=>	__('This ticket was closed, so you can not send the response!','wpo')
			));exit;
		}
		if($response_content==''){
			echo json_encode(array(
				'resp'	=>	'error',
				'mess'	=>	__('Please enter Content!','wpo')
			));exit;
		}
		if( current_user_can( 'add_users' ) || current_user_can( wpo_ticket_cap_update_ticket() ) || current_user_can( wpo_ticket_cap_delete_ticket() )  || get_current_user_id() == wpo_ticket_get_author_id_post_id($post_id) ){		
			$data = array(
				'comment_post_ID'	=>	$post_id,
				'comment_author'	=>	$users->user_login,
				'comment_author_email'	=>	$users->user_email,
				'comment_content'	=>	$response_content,
				'comment_type'	=>	'reply_ticket',
				'user_id'	=>	get_current_user_id(),
				'comment_date'	=>	current_time('mysql'),
				'comment_approved'	=>	10
			);
			$reply_id = wp_insert_comment($data);
			if($reply_id>0){
				### update post_modified
				wp_update_post(array(
					'ID'	=>	$post_id,
					'post_modified'	=>	current_time('mysql')
				));
				### if ticketer make a response, send mail to supporter, else send to ticketer.
				### first, check who send this response?
				if( wpo_ticket_get_author_id_post_id($post_id)== get_current_user_id() ){
					### OK, this is Ticketer, who send this ticket ==> send message to Supporter.
					$department_id = wp_get_post_terms($post_id, 'department', array("fields" => "ids"));
					do_action('pressticket_new_response', $post_id, $response_content, $department_id[0]);
				}
				else{
					### Mail to ticketer
					do_action('pressticket_new_answer',$post_id,$response_content);
				}
				### update ticket status
				update_post_meta($post_id, 'wpo_ticket_status',$status);
				echo json_encode(array(
					'resp'	=>	'success',
					'mess'	=>	__('Send the response successfully.','wpo'),
					'url_ticket'	=>	get_permalink($post_id)
				));exit;
			}
			echo json_encode(array(
				'resp'	=>	'error',
				'mess'	=>	__('ERROR: Please try again.','wpo')
			));exit;		
		}
		else{
			echo json_encode(array(
				'resp'	=>	'error',
				'mess'	=>	__('You do not have the right permission to use this feature!','wpo')
			));exit;
		}
	}
	add_action('wp_ajax_replyticket', 'wpo_ticket_ajax_replyticket');
}

### backend
if(!function_exists('wpo_ticket_admin_action_ticket_status')){
	function wpo_ticket_admin_action_ticket_status() {
		$post_id = $_POST['post_id'];
		$act = $_POST['act'];
		if( current_user_can( wpo_ticket_cap_update_ticket()  ) && $post_id > 0){
			update_post_meta($post_id, 'wpo_ticket_status', $act);
			echo json_encode(array(
				'resp'	=>	'success',
				'mess'	=>	__('Updated success.','wpo')
			));exit;
		}
		else{
			echo json_encode(array(
				'resp'	=>	'error',
				'mess'	=>	__('You do not have the right permission to use this feature!','wpo')
			));exit;
		}
	}
	add_action('wp_ajax_admin_action_ticket_status', 'wpo_ticket_admin_action_ticket_status');
}
if(!function_exists('wpo_ticket_allow_ticket')){
	function wpo_ticket_allow_ticket() {
		if( current_user_can('add_users') ){
			$user_id = $_POST['user_id'];
			$value = $_POST['value'];
			if($value && $user_id){
				if($value=='yes'){
					### add cap open ticket
					$cap = new WP_User( $user_id );
					$cap->add_cap( wpo_ticket_cap_view_ticket());
					echo json_encode(array(
						'resp'	=>	'success'
					));exit;					
				}
				else{
					### remove cap open ticket
					$cap = new WP_User( $user_id );
					$cap->remove_cap( wpo_ticket_cap_view_ticket() );
					echo json_encode(array(
						'resp'	=>	'success'
					));exit;				
				}
			}
		}
		echo json_encode('{"resp":"error","mess"=>"'.__('You do not have permission to use this feature!','wpo').'"}');exit();
	}
	add_action('wp_ajax_allow_ticket', 'wpo_ticket_allow_ticket');
}
if(!function_exists('wpo_ticket_allow_upload_files')){
	function wpo_ticket_allow_upload_files() {
		if( current_user_can('add_users') ){
			$user_id = $_POST['user_id'];
			$value = $_POST['value'];
			if($value && $user_id){
				if($value=='yes'){
					### add cap open ticket
					$cap = new WP_User( $user_id );
					$cap->add_cap( 'upload_files');
					echo json_encode(array(
						'resp'	=>	'success'
					));exit;
				}
				else{
					### remove cap open ticket
					$cap = new WP_User( $user_id );
					$cap->remove_cap( 'upload_files' );
					echo json_encode(array(
						'resp'	=>	'success'
					));exit;
				}
			}
		}
		echo json_encode(array(
			'resp'	=>	'error',
			'mess'	=>	__('You do not have the right permission to use this feature!','wpo')
		));exit;
	}
	add_action('wp_ajax_allow_upload_files', 'wpo_ticket_allow_upload_files');
}
if(!function_exists('wpo_ticket_allow_update_ticket')){
	function wpo_ticket_allow_update_ticket() {
		if( current_user_can('add_users') ){
			$user_id = $_POST['user_id'];
			$value = $_POST['value'];
			if($value && $user_id){
				if($value=='yes'){
					### add cap open ticket
					$cap = new WP_User( $user_id );
					$cap->add_cap( wpo_ticket_cap_update_ticket() );
					echo json_encode(array(
						'resp'	=>	'success'
					));exit;				
				}
				else{
					### remove cap open ticket
					$cap = new WP_User( $user_id );
					$cap->remove_cap( wpo_ticket_cap_update_ticket() );
					echo json_encode(array(
						'resp'	=>	'success'
					));exit;		
				}
			}
		}
		echo json_encode(array(
			'resp'	=>	'error',
			'mess'	=>	__('You do not have the right permission to use this feature!','wpo')
		));exit;
	}
	add_action('wp_ajax_allow_update_ticket', 'wpo_ticket_allow_update_ticket');
}
if(!function_exists('wpo_ticket_allow_delete_ticket')){
	function wpo_ticket_allow_delete_ticket() {
		if( current_user_can('add_users') ){
			$user_id = $_POST['user_id'];
			$value = $_POST['value'];
			if($value && $user_id){
				if($value=='yes'){
					### add cap open ticket
					$cap = new WP_User( $user_id );
					$cap->add_cap( wpo_ticket_cap_delete_ticket() );
					echo json_encode(array(
						'resp'	=>	'success'
					));exit;			
				}
				else{
					### remove cap open ticket
					$cap = new WP_User( $user_id );
					$cap->remove_cap( wpo_ticket_cap_delete_ticket() );
					echo json_encode(array(
						'resp'	=>	'success'
					));exit;
				}
			}
		}
		echo json_encode(array(
			'resp'	=>	'error',
			'mess'	=>	__('You do not have the right permission to use this feature!','wpo')
		));exit;
	}
	add_action('wp_ajax_allow_delete_ticket', 'wpo_ticket_allow_delete_ticket');
}
if(!function_exists('wpo_ticket_ajax_welcome_to')){
	function wpo_ticket_ajax_welcome_to() {
		$settings = $_POST['settings'];
		if( current_user_can('add_users') ){
		if($settings){
			for ($i=0; $i<count($settings);$i++){
				if( $settings[$i]=='allow_open_ticket' ){
					### allow all users open ticket
					$users = get_users();
					if($users){
						foreach ($users as $user){
							$allow_open_ticket = new WP_User( $user->ID );
							$allow_open_ticket->add_cap( wpo_ticket_cap_view_ticket() );
						}
					}
				}
				if( $settings[$i]=='allow_upload_files' ){
					### allow all upload files
					$users = get_users();
					if($users){
						foreach ($users as $user){
							$allow_open_ticket = new WP_User( $user->ID );
							$allow_open_ticket->add_cap( 'upload_files' );
						}
					}
				}
				
			}
			update_option('wpo_ticket_builtsite', 'yes');
			echo json_encode(array(
				'resp'	=>	'success',
				'url_ticket'	=>	admin_url('edit.php?post_type=wp-ticket&page=wp-ticket-settings')
			));exit;	
		}
		else{
			echo json_encode(array(
				'resp'	=>	'error',
				'mess'	=>	__('ERROR: Nothing to do :(','wpo')
			));exit;
			}
		}
		else{
			echo json_encode(array(
				'resp'	=>	'error',
				'mess'	=>	__('You do not have the right permission to use this feature!','wpo')
			));exit;
		}
	}
	add_action('wp_ajax_welcome_to', 'wpo_ticket_ajax_welcome_to');
}
if(!function_exists('wpo_ticket_ignore_settings')){
	function wpo_ticket_ignore_settings(){
		if( current_user_can('add_users') ){
			update_option('wpo_ticket_builtsite', 'yes');
			echo json_encode(array(
				'resp'	=>	'success',
				'url'	=>	admin_url('edit.php?post_type=wp-ticket&page=wp-ticket-settings')
			));exit;
		}
		else{
			echo json_encode(array(
				'resp'	=>	'error',
				'mess'	=>	__('You do not have the right permission to use this feature!','wpo')
			));exit;
		}
	}
	add_action('wp_ajax_ignore_settings', 'wpo_ticket_ignore_settings');
}
//==================== end backend ====================================
if(!function_exists('wpo_ticket_ajax_loadmore')){
	function wpo_ticket_ajax_loadmore() {
		$user_id = get_current_user_id();
		global $wpdb;
		$post_id = (int)$_POST['post_id'];
		$j = (int)$_POST['trclass'];
		if($post_id && user_can($user_id, wpo_ticket_cap_view_ticket())){
			$query = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE `post_status`='publish' AND `post_type`='wp-ticket' AND `post_author`=$user_id AND `ID` < $post_id ORDER BY `ID` DESC LIMIT 10", ARRAY_A);
			if($query){
				foreach ($query as $q){
					$lastest_ticket = $q[ID];
					$j++;
					$trclass = ( $j%2!=0 ) ? 'first' : 'last';
					$terms = wp_get_post_terms( $q[ID], 'department', $args );	
					$department = '<div class="department">'. $terms[0]->name .'</div>';
					$helptopic = get_post_meta($q[ID],'wpo_ticket_helptopics',true) ? '<span class="label">'. get_post_meta($q[ID],'wpo_ticket_helptopics',true) .'</span>' : NULL;
					
					### check woo installed && enable woo support function
					if( WPO_pressticket_woocommerce::check_woocommerce_installed()===true && wpo_ticket_option_ticket_woo_enable()=='yes'){
						if( get_post_meta($q[ID],'wpo_ticket_related_product',true) > 0 ){
							$related_product = __('Related: ','wpo') . '<a href="'.get_permalink( get_post_meta($q[ID],'wpo_ticket_related_product',true) ) .'">' . get_the_title( get_post_meta($q[ID],'wpo_ticket_related_product',true) ) . '</a>';	
						}
						else{
							$related_product = NULL;
						}
					}					
					
					$html .= '
						<tr id="'.$lastest_ticket.'"  class="'.$trclass.'">
							<td>'.wpo_ticket_get_ticketID($q[ID]).'</td>
							<td>'.wpo_ticket_hightlight_status( wpo_ticket_get_ticket_status($q[ID],false)).'</td>
							<td><h3><a href="'. get_permalink($q[ID]).'">'.$q[post_title]. '</a></h3>'.$related_product.'</td>
							<td>'.$department.'</td>
							 <td>'.$helptopic.'</td>
							<td>'. date('F j, Y',strtotime($q[post_date])) .'</td>
							<td>
								'.wpo_ticket_hightlight_priority( wpo_ticket_get_ticket_priority( $q[ID],false ) ).'
							</td>
						</tr>
					';
					
				}
			}
		}
		else{
			return;
		}
		echo json_encode(array('resp'=>'success','data'=>$html,'post_id'=>$lastest_ticket,'trclass'=>$j));exit();
	}
	add_action('wp_ajax_loadmore', 'wpo_ticket_ajax_loadmore');
	add_action('wp_ajax_nopriv_loadmore', 'wpo_ticket_ajax_loadmore');
}
if(!function_exists('wpo_ticket_loginform_act')){
	function wpo_ticket_loginform_act() {
		$username = strip_tags($_POST['username']);
		$password = strip_tags($_POST['password']);
		if(!$username){
			echo json_encode(array('resp'=>'error','mess'=>__('Please enter Username!','wpo')));exit();
		}
		if(!$password){
			echo json_encode(array('resp'=>'error','mess'=>__('Please enter Password!','wpo')));exit();
		}
		else{
			$login = wp_signon(array(
				'user_login'=>$username,
				'user_password'=>$password
			));
			if(!is_wp_error($login)){
				echo json_encode(array(
					'resp'	=>	'success',
					'mess'	=>	__('Login success!','wpo'),
					'url'	=>	wpo_ticket_get_url_createticket()
				));exit;
			}
			else{
				echo json_encode(array(
					'resp'	=>	'error',
					'mess'	=>	$login->get_error_message()
				));
				exit;
			}
		}
	}
	add_action('wp_ajax_nopriv_ticket_loginform', 'wpo_ticket_loginform_act');
}

if(!function_exists('wpo_ticket_ticket_save_settings')){
	function wpo_ticket_ticket_save_settings() {
		header( "Content-Type: application/json" );
		//sleep(3);
		if( current_user_can('add_users') ){
			if($_POST){
				foreach ($_POST as $k=>$v){
					update_option($k, $v);
				}
				flush_rewrite_rules();
				echo json_encode('{"resp":"success","mess":"'.__('Save settings!','wpo').'"}');exit();
			}
		}
		else{
			echo json_encode('{"resp":"error","mess":"'.__('Are\'nt you kidding me!','wpo').'"}');exit();
		}
		//echo json_encode('{"resp":"error","mess":"Error, nothing to built :(!"}');exit();
	}
	add_action('wp_ajax_ticket_save_settings', 'wpo_ticket_ticket_save_settings');
}
if(!function_exists('wpo_ticket_issue_report')){
	function wpo_ticket_issue_report(){
		$plugins = wpo_ticket_get_plugin_data();
		header( "Content-Type: application/json" );
		//add_filter( 'wp_mail_content_type','wpse27856_set_content_type' );
		$subject = '#'.$plugins[Name].' #'.get_bloginfo('url');
		$yourmail = $_POST['youremail'];
		$issue = $_POST['issue'];
		$issue_content = $_POST['issue_content'];
		if( !is_email($yourmail) ){
			echo json_encode('{"resp":"error","mess":"'.__('Email is very important, let me know!','wpo').'"}');exit();
		}
		if(!$issue){
			echo json_encode('{"resp":"error","mess":"'.__('Please talk to me issue summary (issue title)!','wpo').'"}');exit();
		}
		if(strlen($issue_content) <  20){
			echo json_encode('{"resp":"error","mess":"'.__('Please get detailed information to support the fastest, it is seem short, (issue content)!','wpo').'"}');exit();
		}
		
		$message = '
Hi Toan,
Issue: '.$issue.'
Content: '.$issue_content.'<hr/>Email: '.$yourmail.'
		';
		$headers .= "MIME-Version: 1.0\r\n";
		$headers .= "Content-Type: text/html; charset=ISO-8859-1\r\n";		
		if( wp_mail('nttoanbrvt@gmail.com', $subject, nl2br($message), $headers) === true ){
			echo json_encode('{"resp":"success","mess":"'.__('Thanks, I had received your issue, I will contact you as soon as possible.','wpo').'"}');exit();
		}
		else{
			echo json_encode('{"resp":"error","mess":"'.__('Send mail fail, please try again!','wpo').'"}');exit();
		}
	}
	add_action('wp_ajax_issue_report', 'wpo_ticket_issue_report');
}
if(!function_exists('wpo_ticket_get_hello')){
	function wpo_ticket_get_hello() {
		if( !is_user_logged_in()){
			echo json_encode(array('resp'=>'error','mess'=>__('Please login our system to continue ...','wpo')));exit;
		}
		else{
			echo json_encode(array('resp'=>'success','mess'=>__('Logged!','wpo')));exit;
		}
	}	
	add_action('wp_ajax_nopriv_wpo_ticket_get_hello', 'wpo_ticket_get_hello');
	add_action('wp_ajax_wpo_ticket_get_hello', 'wpo_ticket_get_hello');
}

